<?php
/*
 * Poplar Gedcom Viewer
 * Copyright (C) 2002-2003 Nicolas de Vulpian
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*
 * Extensively rewritten 10/2003
 * changes Copyright 2003 by J.R.Grotjan
*/
?>
<?php

// If SAFE_MODE is off, this will allow infinite execution time limit.
@set_time_limit(0);

// And this should allow big memory treatments for huge files
$ini_set = @ini_set( 'memory_limit' , '32M' );

include_once( '../config.php' );                    //$pgv->context['language']
include_once( $pgv->environment['rootPath'].'/lang/'.$pgv->context['language'].'.php' );
include_once( $pgv->environment['rootPath'].'/admin/authenticate.php' );
include_once( $pgv->environment['rootPath'].'/admin/admin_header.php' );

if ( ( file_exists( $pgv->environment['rootPath'].'/install.php' ) ) OR ( file_exists( $pgv->environment['rootPath'].'/install.php' ) ) ) {
    echo '<b><font color=\'#ff0000\'>For security reasons, please delete install.php, upgrade.php and the upgrades folder!!</font></b><br>';
}

if ( !empty( $_POST['action'] ) ) { $_GET['action'] = $_POST['action']; }

switch ( $_GET['action'] ) {
    case GV_EDIT :
        echo '<H2><U>'.GV_ADMIN_EDIT.': '.$pgv->context['genName'].'</U></H2>';
        include( $pgv->environment['rootPath'].'/admin/edit.php' );
        break;

    case 'load_form' :
        echo '<H2><U>'.GV_ADMIN_LOAD.'</U></H2>';
        include( $pgv->environment['rootPath'].'/admin/load_form.php' );
        break;

    case 'load' :
        echo '<H2><U>'.GV_ADMIN_LOAD.'</U></H2>';
        include( $pgv->environment['rootPath'].'/admin/load.php' );
        break;

    case 'manage' :

        echo '<h2><u>'.GV_ADMIN_MANAGE.'</u></h2>';

        $aff_list = true;

        switch ( $_GET['option'] ) {
            case 'more_info' :
                include( $pgv->environment['rootPath'].'/admin/more_info.php' );
                $aff_list = false;
                break;

            case 'delete' :
                gen_delete( $_GET['genID'] );
                break;

            case 'modify' :
                gen_modify( $_GET['genID'] );
                $aff_list = false;
                break;

            case 'modify_ok' :
                $result = $db->Execute( 'UPDATE '.$pgv->table['info']
                .' SET title=\''.$_GET['title'].'\' , theme=\''
                .$_GET['theme'].'\' , owner_name=\''
                .$_GET['owner_name'].'\' , owner_email=\''
                .$_GET['owner_email'].'\' , owner_website=\''
                .$_GET['owner_website'].'\' WHERE genID = \''
                .$_GET['genID'].'\'' );
                if ( $result === false ) die ( 'failed to modify info' );
                break;

        }

        if ( $aff_list == true ) {
            include( $pgv->environment['rootPath'].'/admin/manage.php' );
        }
        break;

    case 'modules' :

        echo '<h2><u>'.GV_ADMIN_MODULES.'</u></h2>';
        include( $pgv->environment['rootPath'].'/admin/modules.php' );
        break;

    case 'settings' :

        echo '<h2><u>'.GV_ADMIN_GLOBAL.'</u></h2>';
        include( $pgv->environment['rootPath'].'/admin/settings.php' );
        break;

    case 'uninstall' :

        echo '<h2><u>'.GV_ADMIN_UNINSTALL.'</u></h2>';
        include( $pgv->environment['rootPath'].'/admin/uninstall.php' );
        break;

    case 'phpinfo' :

        echo '<h2><u>'.GV_ADMIN_PHPINFO.'</u></h2>';

        ob_start();
            $phpinfo = ob_get_contents();
        ob_end_clean();

        $phpinfo = strstr( $phpinfo , '<body>' );
        $phpinfo = str_replace( '<body>' , '' , $phpinfo );
        $phpinfo = str_replace( strstr( $phpinfo , '</body>' ) , '' , $phpinfo );
        $phpinfo = str_replace( ' width="600"' , 'width="450"', $phpinfo );
        echo "\n".$phpinfo;
        break;

    case 'contact' :

        echo '<h2><u>'.GV_ADMIN_CONTACT.'</u></h2>';
        //echo 'If you need some help, please post to <a href=\'http://www.poplargedcomviewer.com/modules/newbb/\' target=\'_blank\'>Poplar Gedcom Viewer Forum</a>,<br>or feel free to send an email to : <a href=\'mailto:webmaster@devulpian.com?subject=PHP%20Gedcom%20Viewer\'>Poplar Gedcom Viewer Mail</a>.';
        //echo 'If you need some help, please post to <a href=\'http://poplar.sourceforge.net'>Poplar Gedcom Viewer Forum</a>;
        break;

    default :

        echo 'Welcome to Poplar Gedcom Viewer.<br><br>';
        break;
}

include ( $pgv->environment['rootPath'].'/admin/admin_footer.php' );
?>