<?php
/*
 * Poplar Gedcom Viewer
 * Copyright (C) 2002-2003 Nicolas de Vulpian
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*
 * Extensively rewritten 10/2003
 * changes Copyright 2003 by J.R.Grotjan
*/
?>
<?php

function validate_file( $file , $option ) {
    if ( ( empty( $file ) ) OR ( !eregi( '^(.*).ged$' , $file , $regs ) )
    OR ( ( $file == 'Select a file below' ) AND ( $option == 'process' ) ) ) {
        return false;
    } else {
        return true;
    }
}

function already_processed( $gedcom_name ) {
    global $db, $pgv;

    $result = $db->Execute( 'SELECT table_name FROM '.$pgv->table['info']
    .' WHERE table_name =\''.$gedcom_name.'\'' );
    if ($result === false) die('failed to test table existence');
    //die('gedcom:'.$gedcom_name.' table name:'.$result->fields['table_name']);
    if ($result->fields['table_name'] == $gedcom_name){
        return true;
    }else{
        return false;
    }
}

function save_date($date) {
    global $tag, $facts, $factID, $prev_tag, $cur_level, $cur_fact, $indiv, $fam;

    if ($date) {
         switch ( $prev_tag ) {
         case 'BIRT' :
             if ( $indiv[ $tag[0]['ref'] ]['birth1'] == '' ){
                 $indiv[ $tag[0]['ref'] ]['birth_range'] = $date['range'];
                 $indiv[ $tag[0]['ref'] ]['birth1'] = $date[1];
                 $indiv[ $tag[0]['ref'] ]['birth2'] = $date[2];
             }else{
                 add_supp_fact ( $indiv[ $tag[0]['ref'] ]['newindID'], $prev_tag, '', $date[1] );
             }
             break;

         case 'DEAT' :
             if ( $indiv[ $tag[0]['ref'] ]['death1'] == '' ){
                 $indiv[ $tag[0]['ref'] ]['death_range'] = $date['range'];
                 $indiv[ $tag[0]['ref'] ]['death1'] = $date[1];
                 $indiv[ $tag[0]['ref'] ]['death2'] = $date[2];
             }else{
                 add_supp_fact ( $indiv[ $tag[0]['ref'] ]['newindID'], $prev_tag, '', $date[1] );
             }
             break;

         case 'MARR' :
             $fam[ $tag[0]['ref'] ]['wedding_range'] = $date['range'];
             $fam[ $tag[0]['ref'] ]['wedding1'] = $date[1];
             $fam[ $tag[0]['ref'] ]['wedding2'] = $date[2];
             break;

         case 'DIV' :
             $fam[ $tag[0]['ref'] ]['divorce_range'] = $date['range'];
             $fam[ $tag[0]['ref'] ]['divorce1'] = $date[1];
             $fam[ $tag[0]['ref'] ]['divorce2'] = $date[2];
             break;

         default :
             $facts[$factID]['tag_name'] = $prev_tag;  //tag that triggered a fact
             $facts[$factID]['date_range'] = $date['range'];
             $facts[$factID]['date1'] = $date[1];
             $facts[$factID]['date2'] = $date[2];
             break;
         }
    }else{
          switch ( $prev_tag ) {
          case 'BIRT' :
               $indiv[ $tag[0]['ref'] ]['birth_phrase'] = $tag[$cur_level]['value'];
          case 'DEAT' :
               $indiv[ $tag[0]['ref'] ]['death_phrase'] = $tag[$cur_level]['value'];
          case 'MARR' :
               $indiv[ $tag[0]['ref'] ]['wedding_phrase'] = $tag[$cur_level]['value'];
          case 'DIV' :
               $indiv[ $tag[0]['ref'] ]['divorce_phrase'] = $tag[$cur_level]['value'];
          default :  //fact record
              $facts[$factID]['date_phrase'] = $tag[$cur_level]['value'];
          }
     }
}

function save_plac() {
    global $tag, $prev_tag, $cur_level, $facts, $factID, $cur_fact, $indiv, $fam;
    if ( eregi( "^[ ,]*(.*[0-9A-Z])[ ,]*$" , $tag[$cur_level]['value'] , $regs ) )
        $tag[$cur_level]['value'] = $regs[1];

    switch ( $prev_tag ) {
        case 'BIRT' :
            $indiv[$tag[0]['ref']]['birth_place'] = $tag[$cur_level]['value'];
            break;

        case 'DEAT' :
            $indiv[$tag[0]['ref']]['death_place'] = $tag[$cur_level]['value'];
            break;

        case 'MARR' :
            $fam[$tag[0]['ref']]['wedding_place'] = $tag[$cur_level]['value'];
            break;

        default :   //facts place        //append in case tag name is already there
            $facts[$factID]['tag_place'] .= $tag[$cur_level]['value'];
            break;
    }
}

function save_caus() {
    global $tag, $prev_tag, $cur_level, $indiv;

    switch ( $prev_tag ) {
        case 'DEAT' :
            $indiv[$tag[0]['ref']]['death_cause'] = $tag[$cur_level]['value'];
            break;
    }
}

//process Notes//
function save_note(&$comments, &$commentID) {
    global $head, $tag, $cur_ref, $cur_level, $cur_value, $indiv, $fam, $noteID, $text;
    $text = '';

    switch ( $tag[0]['tag'] ) {  //which tag the note is related to
    case 'INDI' :                //contains ONLY the ref ID
        $noteID = extract_ref($cur_value) ;
        $indiv[ $tag[0]['ref'] ]['noteID'] = $noteID;
        $commentID[] = $noteID;
        if ( !strchr($tag[$cur_level]['value'],'@') ){  //FamilyTreeMaker only has NOTE ID here
            $comments[count($commentID)-1] = $tag[$cur_level]['value'];
        }
        break;

    case 'FAM' :
        $noteID = extract_ref($cur_value) ;
        $fam[ $tag[0]['ref'] ]['noteID'] = $noteID;
        $commentID[] = $noteID;
        if ( !strchr($tag[$cur_level]['value'],'@') ){  //FamilyTreeMaker only has NOTE ID here
            $comments[count($commentID)-1] = $tag[$cur_level]['value']; //prob.nothing here
        }
        break;

    case 'NOTE' : //if note is lvl 0 then note text follows
        $noteID = $cur_ref ;
        break;
    }
}

function save_conc(&$comments, $text) {
    global $prev_tag, $noteID, $commentID ;

    if ( $prev_tag == 'NOTE' ) {   //should always be true
        $pos = array_search($noteID, $commentID);
        $comments[$pos] .= $text;  //corresponds to ref in prev record
    }
}

function save_cont(&$comments, $text) {
    global $prev_tag, $noteID, $commentID ;

    if ( $prev_tag == 'NOTE' ) {   //should always be true
        $pos = array_search($noteID, $commentID);
        $comments[$pos] .= "\n".$text;  //corresponds to ref in prev record
    }
}

function save_fact($cur_tag, &$facts) {
    global $tag, $cur_level, $cur_ref, $cur_value, $indiv, $fam, $noteID, $factID;

    switch ( $tag[0]['tag'] ) {  //tagname the fact is related to
    case 'FAM' :                 //contains ONLY the ref ID
        if ($cur_level >> 1){
        }else{
            switch ( $cur_tag ){
            case '_MEND' :
            case '_MSTAT' :
               $factID = count($facts)+1 ;   //base 1
               $facts[$factID]['indID'] = $fam[ $tag[0]['ref'] ]['newfamID'];
               $facts[$factID]['type'] = 'F';
               $facts[$factID]['tag_name'] = $cur_tag;
               $facts[$factID]['tag_place'] = $cur_value;  //prob. nothing there
               break;
            }
        }
        break;

    case 'INDI' :
        if ($cur_level >> 1){
            switch ( $tag[1]['tag'] ){
            case 'EVEN' :
            case 'TYPE' :
                $facts[$factID]['tag_name'] = $tag[1]['tag'];
                $facts[$factID]['tag_place'] = $cur_tag.' '.$cur_value.':';
                break;
            default :
                break;
            }
        }else{
            $factID = count($facts)+1 ;   //base 1
            $facts[$factID]['indID'] = $indiv[ $tag[0]['ref'] ]['newindID'];
            $facts[$factID]['type'] = 'I';
            $facts[$factID]['tag_name'] = $cur_tag;
            $facts[$factID]['tag_place'] = $cur_value;  //prob. nothing there
        }
        break;

    default :
        break;
    }
}
$time['start'] = getmicrotime();

$load_ok = true;

switch ( $_POST['option'] ) {
    case 'upload' :
        if ( validate_file( $_FILES['uploaded_file']['name'] , $_POST['option'] ) ) {
            $uploaded_file_rename = strtolower( strtr( $_FILES['uploaded_file']['name'] , ' -' , '__'  ) );
            $gedcom_file = $uploaded_file_rename;
            $gedcom_name = eregi_replace( '.ged' , '' , $gedcom_file );

            if ( !file_exists( $pgv->environment['rootPath'].'/gedcom/'.$uploaded_file_rename ) ) {

                if ( is_uploaded_file( $_FILES['uploaded_file']['tmp_name'] ) ) {

                    if ( !already_processed( $gedcom_name ) ) {

                        if ( move_uploaded_file( $_FILES['uploaded_file']['tmp_name'] , $pgv->environment['rootPath'].'/gedcom/'.$uploaded_file_rename ) ) {
                            echo 'File '.$_FILES['uploaded_file']['name'].' successfully uploaded<br>';
                        } else {
                            $load_ok = false;
                            echo 'Impossible to move '.$_FILES['uploaded_file']['name'].'<br>';
                        }
                    } else {      //need to update to new structure
                        $load_ok = false;
                        echo 'File "'.$gedcom_name.'.ged" already processed.<br>';
                    }
                } else {
                    $load_ok = false;
                    echo 'Possible file upload attack : '.$_FILES['uploaded_file']['name'].'<br>';
                }
            } else {
                $load_ok = false;
                echo 'File '.$uploaded_file_rename.' has already been uploaded.<br>';
            }
        } else {
            $load_ok = false;
            echo 'You have to select a file with .ged extension first.<br>';
        }
        $time['load'] = getmicrotime();
        break;

    case 'process' :
        $time['load'] = $time['start'];
        $gedcom_file = $_POST['processed_file'];
        $gedcom_name = eregi_replace( '.ged' , '' , $gedcom_file );

        if ( validate_file( $gedcom_file , $_POST['option'] ) ) {
            if ( already_processed( $gedcom_name ) ) {
                $load_ok = false;
                echo 'File '.$gedcom_name.' Already Processed<br>';
            } else {
                $load_ok = true;
                echo 'File '.$gedcom_name.'.ged.<br>';
            }
        } else {
            $load_ok = false;
            echo 'You have to select a file with .ged extension first.<br>';
        }
        break;
}

if ( $_POST['theme'] == 'Select a theme' ) {
    $theme = $settings->fields['default_theme'];
} else {
    $theme = $_POST['theme'];
}

if ( $_GET['option'] == 'reload' ) {   //reload data files for sel. gen.
    $time['load'] = $time['start'];
    $result = $db->Execute( 'SELECT table_name, searchized FROM '
    .$pgv->table['info'].' WHERE genID = \''.$_GET['genID'].'\'' );
    if ($result === false) die('failed');  
    $thisGenID = $_GET['genID'];
    $gedcom_name = $result->fields['table_name'];
    $gedcom_file = $gedcom_name.'.ged';
    $table_searchized = $result->fields['searchized'];
}

$gedcom = @fopen( $pgv->environment['rootPath'].'/gedcom/'.$gedcom_file , 'r' );
if ( !$gedcom ) {
    echo 'File '.$gedcom_file.' does not exist!<br>';
    $load_ok = false;
}

$db->Close();
//parse the gedcom file//
$comments = array();      //make sure to cast as array
$commentID = array();     //
$facts = array();
if ( $load_ok !== false ) {
    global $head, $tag, $prev_tag, $cur_level, $cur_value, $factID, $facts
    , $noteID, $indiv, $fam, $comments, $commentID, $text;
    $nextindID = 0;
    $nextfamID = 0;
    $newindID = 0;
    $newfamID = 0;
    $gedcom_line = '';

    while ( !feof( $gedcom ) ) {
        $gedcom_line = fgets( $gedcom , 4096 );
        $regs = 0;

        if ( eregi ( "^([0-9]) ?(@.+@)? ?([_A-Z]{1,6}) ?(.*)" , $gedcom_line , $regs ) ) {
            $cur_level = $regs[1];  //group line/level
            $cur_ref = ( $tag[$cur_level]['ref'] = extract_ref($regs[2])); //id#
            $cur_tag = ( $tag[$cur_level]['tag'] = $regs[3] ); //tag id
            $cur_value = ( $tag[$cur_level]['value'] = trim( $regs[4],"\x00..\x1F" ) );
            if ( $cur_level >> 0){
                $prev_tag = $tag[$cur_level - 1]['tag'];
            }else{      //starting at level 0 again
                //unset($tag);
                $factID = 0;
            }
            $regs = 0;
            switch ( $cur_tag ){
            case 'BIRT' :    //these are handled  //
                 break;      //in conjunction with//
            case 'CAUS' :
                 save_caus();
                 break;
            case 'CONC' :
                 save_conc($comments, $tag[$cur_level]['value']);
                 break;
            case 'CONT' :
                 save_cont($comments, $tag[$cur_level]['value']);
                 break;
            case 'DATE' :
                 $date = convert_date_to_sql($tag[$cur_level]['value']);
                 save_date($date);
                 break;
            case 'DEAT' :
                 break;
            case 'DIV'  :
                 $fam[$tag[0]['ref']]['div'] = true;
                 break;
            case 'FAM'  :
                 if  ( trim($cur_ref) !== '' ){   //skip schema def
                     $fam[$cur_ref]['famID'] = $cur_ref;
                     if ( $_POST['assignID'] != 'on'){
                         $fam[$cur_ref]['newfamID'] = extract_num($cur_ref);
                     }else{
                         $nextfamID ++;
                         $indiv[$cur_ref]['newindID'] = $nextfamID;
                     }
                 }

                 break;
            case 'FAMC' :
                $indiv[$tag[0]['ref']]['famC'] = extract_ref( $tag[1]['value'] );
                break;
            case 'FAMS' :
                break;
            case 'FILE' :
                 if  ( $tag[$cur_level - 1]['tag'] == 'HEAD' ) {
                     $head['file'] = $tag[$cur_level]['value'];
                 }
                 break;
            case 'HEAD' :
                 break;
            case 'HUSB' :
                 $fam[$tag[0]['ref']]['father'] = extract_ref( $tag[$cur_level]['value'] );
                 break;
            case 'INDI' :
                 if  ( trim($cur_ref) !== '' ){   //skip schema def
                     $indiv[$cur_ref]['ID'] = $cur_ref;
                     if ( $_POST['assignID'] != 'on'){
                         $indiv[$cur_ref]['newindID'] = extract_num($cur_ref);
                         if ($indiv[$cur_ref]['newindID'] == 0){  //toggle assign ids on if needed
                             $_POST['assignID'] = 'on';
                             $indiv[$cur_ref]['newindID'] = 1;
                             $nextindID = 1;
                         }
                     }else{
                         $nextindID ++;
                         $indiv[$cur_ref]['newindID'] = $nextindID;
                     }
                 }
                 break;
            case 'LANG' :
                 if  ( $tag[$cur_level - 1]['tag'] == 'HEAD' ) {
                     $head['lang'] = $tag[$cur_level]['value'];
                 }
                 break;
            case 'NAME' :
                 switch ( $prev_tag ) {
                 case 'INDI' :
                     $temp = explode('/', $tag[1]['value']);
                     if ( trim($indiv[ $tag[0]['ref'] ]['name'] ) == '' ){
                         $indiv[ $tag[0]['ref'] ]['firstname'] = trim( $temp[0] );
                         $indiv[ $tag[0]['ref'] ]['name'] = trim( $temp[1] );
                     }else{
                         add_supp_fact ( $indiv[ $tag[0]['ref'] ]['newindID'], $cur_tag, trim( $temp[0] ).' '.trim( $temp[1] ) );
                     }
                     break;
                 case 'SOUR' :
                     $head['sour_name'] = $tag[$cur_level-2]['value'];
                     break;
                 }
                 break;
            case 'NOTE' :
                 save_note($comments, $commentID);
                 break;
            case 'PLAC' :
                 save_plac();
                 break;
            case 'SEX'  :
                 $indiv[$tag[0]['ref']]['gender'] = $tag[1]['value'];
                 break;
            case 'SOUR' :
                 if  ( $prev_tag == 'HEAD' ) {
                     $head['sour'] = $tag[$cur_level]['value'];
                 }
                 break;
            case 'VERS' :
                 if  ( $tag[$cur_level - 2]['tag'] == 'HEAD' ) {
                     $head['sour_version'] = $tag[$cur_level]['value'];
                 }
                 break;
            case 'WIFE' :
                 $fam[$tag[0]['ref']]['mother'] = extract_ref( $tag[$cur_level]['value'] );
                 break;
            //**user defined tags**       //
            case '_MILT':  //military service
            case '_MSTAT': //marriage status//FTW Family tag
            //case '_MREL': //rel.to mother//FTW Family tag
            //case '_FREL': //rel.to father//FTW Family tag
            case '_MEND': //marriage end status//FTW Family tag
            //will have to handle these fam related tags by sub-typing the Facts table
            //which will entail changing some of the ind. facts code jg 01/08/2004 prob.v2.1
            case '_NAMS':  //namesake
            case 'I_TBS':  //image of tombstone//user defined
            case 'I_OBI':  //image of obituary //user defined
            //**end of user defined tags**//
            case 'ABBR' :
            case 'ADDR' :
            case 'ADR1' :
            case 'ADR2' :
            case 'ADOP' :
            case 'AFN'  :
            case 'AGE'  :
            case 'AGNC' :
            case 'ALIA' :
            case 'ANCE' :
            case 'ANCI' :
            case 'ANUL' :
            case 'ASSO' :  //may need some special handling here jg 01/08/2004
            case 'AUTH' :
            case 'BAPL' :
            case 'BAPM' :
            case 'BARM' :
            case 'BASM' :
            case 'BLES' :
            case 'BLOB' :
            case 'BURI' :    //the parent tags    //
            case 'CALN' :
            case 'CAST' :
            case 'CENS' :
            //case 'CHAN' :                 //changed
            case 'CHAR' :
            case 'CHIL' :
            case 'CHR'  :
            case 'CHRA' :
            case 'CITY' :
            case 'CONF' :
            case 'CONL' :
            case 'COPR' :
            case 'CORP' :
            case 'CREM' :
            case 'CTRY' :
            case 'DATA' :
            case 'DESC' :
            case 'DESI' :
            case 'DEST' :
            case 'DIVF' :
            case 'DSCR' :
            case 'EDUC' :
            case 'EMIG' :
            case 'ENDL' :
            case 'ENGA' :
            //case 'EVEN' :         //cur. using for images, dont process
            case 'FAMF' :
            case 'FCOM' :
            case 'FORM' :
            case 'GEDC' :
            case 'GIVN' :
            case 'GRAD' :
            case 'IDNO' :
            case 'IMMI' :
            case 'LEGA' :
            case 'MARB' :
            case 'MARC' :
            case 'MARL' :
            case 'MARR' :
            case 'MARS' :
            case 'MEDI' :
            case 'NATI' :
            case 'NATU' :
            case 'NCHI' :
            case 'NICK' :
            case 'NMR'  :
            case 'NPFX' :
            case 'NSFX' :
            //case 'OBJE' :
            case 'OCCU' :
            case 'ORDI' :
            case 'ORDN' :
            //case 'PAGE' :
            case 'PEDI' :
            case 'PHON' :
            case 'POST' :
            case 'PROB' :
            case 'PROP' :
            case 'PUBL' :
            case 'QUAY' :
            //case 'REFN' :             //ref.num.
            case 'RELA' :
            case 'RELI' :
            case 'REPO' :
            case 'RESI' :
            case 'RESN' :
            case 'RETI' :
            //case 'RFN'  :              //ref.num.
            case 'RIN'  :
            case 'ROLE' :
            case 'SLGC' :
            case 'SLGS' :
            case 'SPFX' :
            //case 'SSN'  :              //soc.sec.num.
            case 'STAE' :
            case 'STAT' :
            case 'SUBM' :
            case 'SUBN' :
            case 'SURN' :
            case 'TEMP' :
            case 'TEXT' :
            case 'TIME' :
            case 'TITL' :
            case 'TRLR' :
            case 'TYPE' :
            case 'WILL' :
                //for each addtl tag related to an INDI or FAM, add a fact record
                save_fact( $cur_tag , $facts);
                break;
            default :
                unset($factID);  //may have child tags, clear prev. ID
                break;           //so child tags will be skipped
            }
        }
    }

    $time['process'] = getmicrotime();

    $db->Connect( $dbhost , $dbuser , $dbpassword , $dbname);
    if ( $db === false ) die ( 'Connection failed' );

    // Add a line corresponding to the genealogy processed. If 'reload', updates it.

    if ( $_GET['option'] != 'reload' ) {  //NOT a reload
        $query = 'SELECT MAX(genID) AS thisGenID FROM '.$pgv->table['info'] ;
        $result = $db->Execute( $query );
        if ($result === false) {
            $thisGenID = 1;
        }else{
            $thisGenID = ($result->fields['thisGenID']) + 1;
        }
        $query =  'INSERT INTO '.$pgv->table['info']
        .' VALUES( \''.$thisGenID.'\' , \''
        .addslashes($gedcom_name).'\' , \''
        .addslashes($_POST['title']).'\' , \''
        .addslashes($_POST['owner_name']).'\' , \''
        .$_POST['owner_email'].'\' , \''
        .$_POST['owner_website'].'\' , \''
        .$head['crea_date'].'\' , \''
        .addslashes($head['sour']).'\' , \''
        .addslashes($head['sour_vers']).'\' , \''
        .addslashes($head['sour_name']).'\' , \''
        .$head['lang'].'\' , \''
        .addslashes($head['file']).'\' , \''
        .addslashes($theme).'\' , \'\' , \'0\' , \'\' , \'\' );' ;

        $result = $db->Execute( $query );
        if ($result === false) die('failed to add '.$pgv->table['info'].':'.$query);

    } else {                   //IS a reload
        $result = $db->Execute( 'UPDATE '.$pgv->table['info']
        .' SET crea_date=\''.$head['crea_date']
        .'\' , sour=\''.addslashes($head['sour'])
        .'\' , sour_version=\''.addslashes($head['sour_vers'])
        .'\' , sour_name=\''.addslashes($head['sour_name'])
        .'\' , lang=\''.$head['lang']
        .'\' , file=\''.addslashes($head['file'])
        .'\' WHERE genID=\''.$_GET['genID'].'\'' );
        if ($result === false) die('failed to update '.$pgv->table['info']
        .', genID='.$_GET['genID'].' while reloading');

        gen_delete($_GET['genID'], 1);
    }

    // Loads Individuals table

    //set up ID base for comment ID, used for ind, fam and cmt
    $base = $db->Execute( 'SELECT MAX(commentID) AS nb FROM '.$pgv->table['comments'] ) ;
    if ($base !== false) {
        $idBase = $base->fields['nb'];
    }else{
        $idBase = 0;
    }

    $result = $db->Execute( 'LOCK TABLE '.$pgv->table['individuals'].' WRITE;' );
    if ($result === false) die('failed');

    foreach ( $indiv as $value ) {
        if (  trim($value['noteID']) != '' ) {
            $pos = array_search( $value['noteID'], $commentID );
            $pos += ($idBase + 1);  //base 1
        }else{
            $pos = 0;  //couldnt find it in the comment array
        }
        if ( $value['newindID'] > 0 ){
            $query = 'INSERT INTO '.$pgv->table['individuals']
            .' VALUES ( \''.$thisGenID.'\' , \''
            .$value['newindID'].'\' , \''
            .addslashes($value['name']).'\' , \''
            .addslashes($value['firstname']).'\' , \'\' , \''
            .$value['gender'].'\' , \''
            .$value['birth_range'].'\' , \''
            .$value['birth1'].'\' , \''
            .$value['birth2'].'\' , \''
            .addslashes($value['birth_phrase']).'\' , \''
            .addslashes($value['birth_place']).'\' , \''
            .$value['death_range'].'\' , \''
            .$value['death1'].'\' , \''
            .$value['death2'].'\' , \''
            .addslashes( $value['death_phrase'] ).'\' , \''
            .addslashes( $value['death_place'] ).'\' , \''
            .addslashes( $value['death_cause'] ).'\' , \''
            .$pos.'\' , \''
            .$fam[$value['famC']]['newfamID'].'\' );';

            $result = $db->Execute($query);
            if ($result === false) die('failed to add Individual: '.var_dump($value) );
        }
    }

    $result = $db->Execute( 'UNLOCK TABLES;' );
    if ($result === false) die('failed to unlock Individuals');

    $time['individuals'] = getmicrotime();

    // Loads Families table
    $result = $db->Execute( 'LOCK TABLE '.$pgv->table['families'].' WRITE;' );
    if ($result === false) die('failed to lock Families');

    foreach ($fam as $value) {
        if ( trim($value['noteID']) != '' ) {
            $pos = array_search( $value['noteID'], $commentID );
            $pos += ($idBase + 1);  //base 1
        }else{
            $pos = 0;  //couldnt find it in the comment array
        }
        $query = 'INSERT INTO '.$pgv->table['families']
        .' VALUES ( \''.$thisGenID.'\' , \''
        .$value['newfamID'].'\' , \''
        .$value['wedding_range'].'\' , \''
        .$value['wedding1'].'\' , \''
        .$value['wedding2'].'\' , \''
        .addslashes( $value['wedding_phrase'] ).'\' , \''
        .addslashes( $value['wedding_place'] ).'\' , \''
        .$value['divorce_range'].'\' , \''
        .$value['divorce1'].'\' , \''
        .$value['divorce2'].'\' , \''
        .addslashes( $value['divorce_phrase'] ).'\' , \''
        .$value['div'].'\' , \''
        .$indiv[$value['father']]['newindID'].'\' , \''
        .$indiv[$value['mother']]['newindID'].'\' , \''
        .$pos.'\' );' ;

        $result = $db->Execute( $query );
        if ($result === false) die('failed to add Family record '.$query);
    }

    $result = $db->Execute( 'UNLOCK TABLES;' );
    if ($result === false) die('failed to unlock Families');
    $time['families'] = getmicrotime();

    // Loads comments table
    $result = $db->Execute( 'LOCK TABLE '.$pgv->table['comments'].' WRITE;' );
    if ($result === false) die('failed to lock Comments');
                            //key => value
    foreach ( $commentID as $pos => $noteID ) {
        $posI = $idBase + $pos + 1;  //base 1
        $query = 'INSERT INTO '.$pgv->table['comments']
        .' VALUES ( \''.$posI.'\' , \''.$thisGenID.'\' , \''.addslashes( $comments[$pos] ).'\' );' ;

        $result = $db->Execute( $query );
        if ($result === false) die('failed to add Comment: '.$query);
    }

    $result = $db->Execute( 'UNLOCK TABLES;' );
    if ($result === false) die('failed to unlock Comments');
    $time['comments'] = getmicrotime();

    // Load Facts table
    $result = $db->Execute( 'LOCK TABLE '.$pgv->table['facts'].' WRITE;' );
    if ($result === false) die('failed to lock Facts');

    foreach ($facts as $value) {

        $query = 'INSERT INTO '.$pgv->table['facts']
        .' VALUES ( NULL ,\''
        .$thisGenID.'\' , \''
        .$value['indID'].'\' , \''
        .$value['type'].'\' , \''
        .$value['tag_name'].'\' , \''
        .$value['date_range'].'\' , \''
        .$value['date1'].'\' , \''
        .$value['date2'].'\' , \''
        .addslashes( $value['date_phrase'] ).'\' , \''
        .addslashes( $value['tag_place'] ).'\' );' ;

        $result = $db->Execute( $query );
        if ($result === false) die('failed to add Fact: '.$query);
    }

    $result = $db->Execute( 'UNLOCK TABLES;' );
    if ($result === false) die('failed to unlock Facts');
    $time['facts'] = getmicrotime();

    $query = 'SELECT count( ID ) AS nb FROM '.$pgv->table['individuals'].' WHERE genID = '.$thisGenID;
    $individuals = $db->Execute( $query );
    if ($individuals === false) die('failed individual count: '.$query);

    if ( $individuals->fields['nb'] != 0 ) {
        echo 'Database successfully loaded !<br><br>';
        echo count($indiv).' individuals added.<br>';
        echo count($fam).' families added.<br>';
        echo count($commentID).' comments added.<br>';
        echo count($facts).' facts added.<br>';
    } else {
        echo 'Database failed to load...';
    }

    if ( $_GET['option'] == 'reload' ) {
        if ( $table_searchized == true ) {
            gen_unsearchize( $_GET['genID'] );
            echo '<br />Caution : the soundex index of this genealogy has been removed.<br />';
        }
    }
    echo '<br /><br />';

    $time['database'] = getmicrotime();
    echo 'Download time : '.number_format( $time['load'] - $time['start'] , 2 ).' s<br>';
    echo 'File process : '.number_format( $time['process'] - $time['load'] , 2 ).' s<br>';
    echo 'Database load : '.number_format( $time['database'] - $time['process'] , 2 ).' s :<br>';

    echo ' - Individuals table : '.number_format( $time['individuals'] - $time['process'] , 2 ).' s<br>';
    echo ' - Families table : '.number_format( $time['families'] - $time['individuals'] , 2 ).' s<br>';
    echo ' - Comments table : '.number_format( $time['comments'] - $time['families'] , 2 ).' s<br>';
    echo ' - Facts table : '.number_format( $time['facts'] - $time['comments'] , 2 ).' s<br>';
}
function add_supp_fact($indID, $tag, $place, $date=''){
    global $facts;

    $factID = count($facts)+1;
    $facts[$factID]['indID'] = $indID;
    $facts[$factID]['type'] = 'I';
    if ($date != '') $facts[$factID]['date1'] = $date;
    $facts[$factID]['tag_name'] = $tag;
    $facts[$factID]['tag_place'] = $place;
    unset($factID);

}
?>