<?php
/*
 * Poplar Gedcom Viewer
 * Copyright (C) 2002-2003 Nicolas de Vulpian
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*
 * Extensively rewritten 10/2003
 * changes Copyright 2003 by J.R.Grotjan
*/
?>
<?php

    $pgv->setMainMenuTitle( GV_SEARCH );

    $tab['name']['text'] = str_replace( '+\,:' , ' ' , trim( $_GET['name'] ) );
    $tab['name']['field'] = 'ind.name';
    $tab['firstname']['text'] = str_replace( '+\,:' , ' ' , trim( $_GET['firstname'] ) );
    $tab['firstname']['field'] = 'ind.firstname';
    //$tab['occupation']['text'] = str_replace( '+\,:' , ' ' , trim( $_GET['occupation'] ) );
    //$tab['occupation']['field'] = 'ind.occupation';
    $tab['comment']['text'] = str_replace( '+\,:' , ' ' , trim( $_GET['comment'] ) );
    $tab['comment']['field'] = 'com.text';

    $tab_count = count( $tab );
    foreach( $tab as $value ) {
        if ( !empty( $value['text'] ) ) {
            $queryPast .= $value['field'].' LIKE \'%'.$value['text'].'%\' OR ';
        }
    }
    if ( substr( $queryPast , -3 , 3 ) ) {
        $queryPast = substr( $queryPast , 0 , -3 );
    }
    $queryPast .= ' )';

    if ( $pgv->context['isGen'] ) {      //specific genealogy
        $query = 'SELECT ind.genID , ind.ID , ind.name , ind.firstname , ind.birth_range
        , ind.birth1 , ind.birth2 , ind.birth_phrase , ind.death_range
        , ind.death1 , ind.death2 , ind.death_phrase
        , com.text FROM '.$pgv->table['individuals'].' AS ind LEFT JOIN '
        .$pgv->table['comments']
        .' AS com ON ind.commentID = com.commentID WHERE ';

       if ($pgv->privacy['living_names']=='Y'){  //add privacy check
            $query .= '(ind.birth1 < "'.$pgv->privacy['living_birth']
            .'-00-00" OR ind.death1 > "0000-00-00") AND ';
       }

        $query .= '( ind.genID = '.$pgv->context['genID'].' AND ';
        $query.= $queryPast;
    } else {                            //global search
        //take privacy settings from 1st genealogy in info file
        $pquery = 'SELECT living_names, living_birth from '.$pgv->moduleTable('privacy') ;
        $privacy = $db->Execute( $pquery );

        $query = 'SELECT ind.genID , ind.ID , ind.name , ind.firstname , ind.birth_range
        , ind.birth1 , ind.birth2 , ind.birth_phrase , ind.death_range
        , ind.death1 , ind.death2 , ind.death_phrase , info.table_name FROM '
        .$pgv->table['individuals'].' AS ind , '.$pgv->table['info'].' AS info WHERE ';

        if ($privacy->fields['living_names']=='Y'){  //add privacy check
            $query .= '(ind.birth1 < "'.$privacy->fields['living_birth']
            .'-00-00" OR ind.death1 > "0000-00-00") AND ';
        }

        $query .= '( '.$queryPast.' AND ind.table_name = info.table_name';
    }

    if ( empty( $_GET['page_nb'] ) ) $_GET['page_nb'] = 1;
    //echo $query;
    $result = $db->PageExecute( $query, $pgv->settings['result_number'], $_GET['page_nb'] );
    if (!$result) die('search failed: '.$query);

    $i = 0;
    if ( !$result->EOF ) {
        while ( !$result->EOF ) {
            $pgv->emptyUrl();

            if ( !empty( $pgv->context['genID'] ) ) {
                $pgv->setUrl( 'genID' , $pgv->context['genID'] );
            } else {
                $pgv->setUrl( 'genID' , $result->fields['genID'] );
            }

            $pgv->setUrl( 'page' , 'ind' );
            $pgv->setUrl( 'indID' , $result->fields['ID'] );
            $pgv->setUrl( 'ul' , $pgv->context['ul'] );

            $pgv_search['results'][++$i]['name']
            = $pgv->makeLink( stripslashes( $result->fields['name'] ).' '
            .stripslashes( $result->fields['firstname'] ) );

            $pgv_search['results'][$i]['name']
            .= ' <font size=\'1\'>('
            .convert_sql_to_date( $result->fields['birth_range']
            , $result->fields['birth1'] , $result->fields['birth2']
            , $result->fields['birth_phrase'] , 3 ).' - '
            .convert_sql_to_date( $result->fields['death_range']
            , $result->fields['death1'] , $result->fields['death2']
            , $result->fields['death_phrase'] , 3 ).')</font>';

            if ( $pgv->context['isGen'] ) {
                if ( !empty( $tab['occupation']['text'] )
                && eregi( $tab['occupation']['text'] , $result->fields['occupation'] )
                && !$hide( 'occupation' , $result->fields['birth1'] ) ) {
                    $pgv_search['results'][$i]['occupation']
                    = eregi_replace( $tab['occupation']['text']
                    , '<span class="occurence">\0</span>'
                    , quote( stripslashes( $result->fields['occupation'] )
                    , $tab['occupation']['text'] ) ).'</li>'."\n";
                }
                if ( !empty( $tab['comment']['text'] )
                && eregi( $tab['comment']['text'] , $result->fields['text'] )
                && !$hide( 'notes' , $result->fields['birth1'] ) ) {
                    $pgv_search['results'][$i]['note']
                    = eregi_replace( $tab['comment']['text']
                    , '<span class="occurence">\0</span>'
                    , quote( stripslashes( $result->fields['text'] )
                    , $tab['comment']['text'] ) ).'</li>'."\n";
                }
            }
            $result->MoveNext();
        }
        $result->MoveFirst();

        if ( !$result->EOF
        && ( !$result->AtFirstPage()
        || !$result->AtLastPage() ) ) {
            if ( !$result->AtFirstPage() ) {
                $pgv_search['navigation'] = '<a href=\'index.php?genID='
                .$pgv->context['genID'].'&amp;page=asearch&amp;name='
                .$_GET['name'].'&amp;firstname='.$_GET['firstname']
                .'&amp;occupation='.$_GET['occupation']
                .'&amp;comment='.$_GET['comment']
                .'&amp;page_nb='.( $result->AbsolutePage() - 1 )
                .'&amp;ul='.$pgv->context['ul'].'\'>'.GV_SEARCH_PREVIOUS.'</a>';
            }

            if ( !$result->AtFirstPage()
            && !$result->AtLastPage() ) {
                $pgv_search['navigation'] .=  ' | ';
            }

            if ( !$result->AtLastPage() ) {
                $pgv_search['navigation'] .=  '<a href=\'index.php?genID='
                .$pgv->context['genID'].'&amp;page=asearch&amp;name='
                .$_GET['name'].'&amp;firstname='.$_GET['firstname']
                .'&amp;occupation='.$_GET['occupation'].'&amp;comment='
                .$_GET['comment'].'&amp;page_nb='.( $result->AbsolutePage() + 1 )
                .'&amp;ul='.$pgv->context['ul'].'\'>'.GV_SEARCH_NEXT.'</a>';
            }
        }
    } else {
        if ( ( !isset( $_GET['approx'] ) ) OR ( empty( $_GET['approx'] ) ) ) {
            $pgv_search['soundex'] = true;
            $pgv_search['soundex_form'] = GV_APPROXIMATIVE_SEARCH
                .'<form name=\'approximative\' method=\'get\' action=\''
                .$pgv->context['rootUrl'].'/index.php\'>'
                .'<input type=\'text\' name=\'text\' value=\''
                .$_GET['text'].'\' style=\'input1\'>'
                .'<input type=\'hidden\' name=\'genID\' value=\''
                .$pgv->context['genID'].'\'>'
                .'<input type=\'hidden\' name=\'page\' value=\'search\'>'
                .'<input type=\'hidden\' name=\'approx\' value=\'true\'>'
                .'<input type=\'hidden\' name=\'ul\' value=\''.$pgv->context['ul'].'\'>'
                .'<input type=\'hidden\' name=\'start\' value=\'0\'>'
                .'<input type=\'submit\' value=\''.GV_SEARCH_BUTTON_LABEL.'\'>'
                .'</form>';
        }
    }

    $pgv_search['no_result'] = GV_SEARCH_NORESULT;
    $theme->assign( 'pgv_search' , $pgv_search );
?>