<?php
/*
 * Poplar Gedcom Viewer
 * Copyright (C) 2002-2003 Nicolas de Vulpian
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*
 * Extensively rewritten 10/2003
 * changes Copyright 2003 by J.R.Grotjan
*/
?>
<?php
// Displays an individual's informations
    global $GV_TAG;
    $ind = new individual( $pgv->context['genID'] , $pgv->context['indID'] );
    $ind->getIndividual();

    $pgv->setMainMenuTitle( $ind->fullName );

    // Displays personal informations : first name, name, gender, birth , death date, occupation, individual notes
    $pgv_ind_infos['title'] = GV_INFO;
    switch($ind->gender){
        case 'M' :
            $gender = GV_GENDER_M;
            break;
        case 'F' :
            $gender = GV_GENDER_F;
            break;
        default  :
            $gender = GV_GENDER_U;
            break;
    }
    $pgv_ind_infos['list'][] = fill( GV_GENDER , $gender );

    // Photo module related code
    if ( $pgv->privacy['all_facts'] != 'Y'
    &&( ($pgv->privacy['living_facts'] == 'Y'
    && isLiving( $ind->hiddenbirth['date1'] , $ind->hiddendeath['date1'] )===false )
    || $pgv->privacy['living_facts'] != 'Y') ){

        $pgv_ind_photos['date_taken'] = GV_MODULE_PHOTOS_DT_TAKEN;
        $pgv_ind_photos['courtesy_of'] = GV_MODULE_PHOTOS_COURTESY_OF;

        $result = $db->Execute( 'SELECT image_root FROM '.$pgv->moduleTable( 'photo_book' )
        .' WHERE genID="'.$pgv->context['genID'].'"' );
        $result2 = $db->Execute( 'SELECT * FROM '.$pgv->moduleTable( 'photo_entry' )
        .' WHERE genID="'.$pgv->context['genID'].'" AND ind_id='.$pgv->context['indID']
        .' AND photo_order=1' );
        $result3 = $db->Execute( 'SELECT COUNT(peID) AS peRecs FROM '
        .$pgv->moduleTable( 'photo_entry' )
        .' WHERE genID="'.$pgv->context['genID'].'" AND ind_id='.$pgv->context['indID'] );
        if ( $result2->fields['photo_order'] == 1 ){
           $pgv_ind_photos['photo'] = $result->fields['image_root'].'/'
           .$result2->fields['photo_path'];
           $pgv_ind_photos['photoname'] = $result2->fields['photo_name'];
           $pgv_ind_photos['photodesc'] = $result2->fields['photo_desc'];
           $pgv_ind_photos['photosource'] = $result2->fields['photo_source'];
           $date['date1']=$result2->fields['photo_date'];
           $pgv_ind_photos['photodate'] = formatDate( $date );
        }else{
           unset($pgv_ind_infos['photo']);
        }
        if ($result3->fields['peRecs'] >> '1'){
          $pgv_ind_photos['photocount'] = $result3->fields['peRecs'];
          $pgv->getUrl();
          $pgv->setUrl( 'page' , 'photo_list' );
          $pgv_ind_photos['photolink'] = $pgv->makeLink( GV_MODULE_PHOTOS_MORE_PHOTOS );
        }
        unset($result);
        unset($result2);
        unset($result3);
    }
    // end of Photo module code

    //Individual Info
    if ( ( formatDate( $ind->birth ) != '' || !empty( $ind->birth['place'] ) ) ) {

        $pgv_ind_infos['list'][] = fill( GV_BIRTH , formatDate( $ind->birth ) );

        if ( $ind->birth['place'] ) {
            $pgv_ind_infos['list'][] .= ' ('.$ind->birth['place'].')';
        }
    }

    if ( ( formatDate( $ind->death ) != '' || !empty( $ind->death['place'] ) ) ) {

        $pgv_ind_infos['list'][] = fill( GV_DEATH , formatDate( $ind->death ) );

        if ( !empty( $ind->death['place'] ) ) {
            $pgv_ind_infos['list'][] .= ' ('.$ind->death['place'].')';
        }
    }
    if ( !empty( $ind->death['cause'] ) ) {

        $pgv_ind_infos['list'][] = fill( GV_DEATH_CAUSE , $ind->death['cause'] );

    }

    if ( ( formatDate( $ind->burial ) != '' || !empty( $ind->burial['place'] ) ) ) {

        $pgv_ind_infos['list'][] = fill( GV_BURIAL , formatDate( $ind->burial ) );

        if ( !empty( $ind->burial['place'] ) ) {
            $pgv_ind_infos['list'][] .= ' ('.$ind->burial['place'].')';
        }
    }
    // Displays additional facts
    $pgv_ind_facts['title'] = GV_FACTS_INDIV;
    if ( $ind->getAllFacts() ) {
        $pgv_ind_facts['factCount'] = $ind->factsCount;
        for ( $i = 0 ; $i < $ind->factsCount ; $i++ ) {
            $tagName = $ind->fact[$i]['name'];
            if ( $GV_TAG[$tagName]!= '' ){
                $name = $GV_TAG[$tagName];
            }else{
                $name = $tagName;
            }
            $date = $ind->fact[$i];
            $pgv_ind_facts['list'][] = '<td>'.$name.'<td>'
            .(formatDate($date)).'<td>'.$ind->fact[$i]['place'];
        }
    }
    // Displays Ind Comments
    $strlen_comments = strlen( $ind->note );
    if ( $strlen_comments > 0 ) {
        $pgv->getUrl();
        $pgv->setUrl( 'page' , 'indiv_note' );

        $pgv_ind_notes['title'] = GV_COMMENTS_INDIV;
        $pgv_ind_notes['text'] = $ind->note;
        $pgv_ind_notes['more'] = $pgv->makeLink( GV_COMMENTS_MORE );
    }

    // Displays parents names
    $pgv_ind_parents['title'] = GV_PARENTS;

    if ( $ind->getParents() ) {
        for ( $i = 0 ; $i < $ind->parentsCount ; $i++ ) {
            $pgv->getUrl();
            $pgv->setUrl( 'indID' , $ind->parents[$i]->indID );
            $pgv_ind_parents['list'][] = fill( ( $ind->parents[$i]->gender == 'M' ? GV_FATHER : GV_MOTHER ) , ( $ind->parents[$i]->indID > 0 ? $pgv->makeLink( $ind->parents[$i]->fullName ) : GV_NO_PARENTS ) );
        }
    } else {
            $pgv_ind_parents['empty'] = GV_NO_PARENTS;
    }

    // Displays spouses information
    $pgv_ind_spouses['title'] = GV_SPOUSE;

    if ( $ind->getSpouses() ) {

        $pgv->getUrl();

        for ( $i = 0 ; $i < $ind->spousesCount ; $i++ ) {
            $pgv->getUrl();

            $pgv->setUrl( 'indID' , $ind->spouses[$i]->indID );

            if ($ind->spousesCount > 1){
              $temp = '<font size="-2">('.($i+1).')</font>'
              .$pgv->makeLink( $ind->spouses[$i]->fullName );
            }else{
              $temp = $pgv->makeLink( $ind->spouses[$i]->fullName );
            }
            if ( formatDate($ind->spouses[$i]->wedding) != '' ) {
                $temp .= ' - '.fill( GV_WEDDING , formatDate($ind->spouses[$i]->wedding) );
            }
            if ( $ind->spouses[$i]->wedding['place'] != '' ) {
                $temp .= ' ('.$ind->spouses[$i]->wedding['place'].')';
            }
            if ( $ind->spouses[$i]->divorce['div']
            && formatDate($ind->spouses[$i]->divorce) != '' ) {
                $temp .= ' - '.fill( GV_DIVORCE , formatDate($ind->spouses[$i]->divorce));
            }

            if ( trim( $ind->spouses[$i]->note ) != '' ) {
                $pgv->setUrl( 'page' , 'couple_note' );
                $pgv->setUrl( 'genID' , $ind->genID );
                $pgv->setUrl( 'indID' , $ind->indID );
                $pgv->setUrl( 'spouseID' , $ind->spouses[$i]->indID );

                $temp .= ' ('.( ( strlen( $ind->spouses[$i]->note ) < 40 )
                ? $ind->spouses[$i]->note : $pgv->makeLink( '<b>'
                .GV_COMMENTS_COUPLE.'</b>' ) ).')';
            }
            $pgv_ind_spouses['list'][] = $temp;
            $pgv_ind_spouses['list_id'][] = $ind->spouses[$i]->indID;
        //  Displays marriage facts
            if ( $ind->spouses[$i]->getAllFacts('F') ) {
                for ( $f = 0 ; $f < $ind->spouses[$f]->factsCount ; $f++ ) {
                    $tagName = $ind->spouses[$i]->fact[$f]['name'];
                    if ( $GV_TAG[$tagName]!= '' ){
                        $name = $GV_TAG[$tagName];
                    }else{
                        $name = $tagName;
                    }
                    $date = $ind->spouses[$i]->fact[$f];
                    //$pgv_marr_facts['list'][]
                    $pgv_ind_spouses['list'][] = '&nbsp;&nbsp;&nbsp;<b><font size="-1">'.$name.'</font></b>'
                    .(formatDate($date)).' - '.$ind->spouses[$i]->fact[$f]['place'];
                }
            }
        }
    } else {
        $pgv_ind_spouses['empty'] = GV_NO_SPOUSE;
    }
    // Displays children's names
    $pgv_ind_children['title'] = GV_CHILDREN;

    if ( $ind->getChild() ) {
        $pgv->getUrl();

        for ( $i = 0 ; $i < $ind->childCount ; $i++ ) {
            $pgv->setUrl( 'indID' , $ind->child[$i]->indID );
            if ($ind->spousesCount > 1){
                $query = 'SELECT mother, father FROM '.$pgv->table['families']
                .' WHERE genID = '.$ind->child[$i]->genID.' AND famID = '.$ind->child[$i]->famC ;
                $result = $db->Execute( $query );
                if ( $ind->gender == 'M' ){
                  $parent = $result->fields['mother'];
                }else{
                  $parent = $result->fields['father'];
                }
                $parent_ord = array_search($parent, $pgv_ind_spouses['list_id']);
                $pgv_ind_children['list'][] = '<td><font size="-2">('
                .($parent_ord+1).')</font><td align="right">'
                .formatDate($ind->child[$i]->birth)."&nbsp<td>&nbsp"
                .$pgv->makeLink( $ind->child[$i]->fullName );
            }else{
                $pgv_ind_children['list'][] = '<td align="right">'
                .formatDate($ind->child[$i]->birth)."&nbsp<td>&nbsp"
                .$pgv->makeLink( $ind->child[$i]->fullName );
            }
        }
    } else {
        $pgv_ind_children['empty'] = GV_NO_CHILD;
    }

    $theme->assign( 'pgv_ind_infos'  ,  $pgv_ind_infos );
    $theme->assign( 'pgv_ind_photos' ,  $pgv_ind_photos );
    $theme->assign( 'pgv_ind_notes'  ,  $pgv_ind_notes );
    $theme->assign( 'pgv_ind_facts'  ,  $pgv_ind_facts );
    $theme->assign( 'pgv_ind_parents',  $pgv_ind_parents );
    $theme->assign( 'pgv_ind_spouses',  $pgv_ind_spouses );
    $theme->assign( 'pgv_ind_children', $pgv_ind_children );
?>

