<?php
/*
 * Poplar Gedcom Viewer
 * Copyright (C) 2002-2003 Nicolas de Vulpian
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*
 * Extensively rewritten 10/2003
 * changes Copyright 2003, 2004 by J.R.Grotjan
*/
?>
<?php

    $pgv->setMainMenuTitle( GV_SEARCH );
    $pgv->setPageTitle( $pgv->context['genTitle'].' - '.GV_SEARCH.' : '.$_GET['text'] );

    $pgv_search['query'] = GV_SEARCH_REQUEST." : ".$_GET['text'];

    $tab = parSrch( $_GET['text'] );
    $nb = count($tab);

    $reg_tab = '('.str_replace( ' ' , '|' , $mots ).')';

    if ( $nb !== false ) {   //a search WAS entered
        if ( $pgv->context['isGen'] ) {        //IS specific genealogy
            $query = 'SELECT ind.genID , ind.ID , ind.name , ind.firstname
            , ind.birth_range , ind.birth1 , ind.birth2 , ind.birth_phrase
            , ind.death_range , ind.death1 , ind.death2 , ind.death_phrase , com.text'
                .' FROM '.$pgv->table['individuals'].' AS ind'
                .' LEFT JOIN '.$pgv->table['comments'].' AS com'
                .' ON ind.commentID = com.commentID'
                .' WHERE ind.genID = '.$pgv->context['genID'].' AND ';
                //add WHERE clause

            if ($pgv->privacy['living_names']=='Y'){  //add privacy check
                $query .= '(ind.birth1 < "'.$pgv->privacy['living_birth']
                .'-00-00" OR ind.death1 > "0000-00-00") AND ';
            }

            for ( $i = 0 ; $i < $nb ; $i++ ) {
                //And check ea. item against each search mote
                if ( !isset( $_GET['approx'] ) OR empty( $_GET['approx'] ) ) {
                    $query .= '( ind.name LIKE \'%'.$tab[$i].'%\''
                        .' OR ind.firstname LIKE \'%'.$tab[$i].'%\''
                        .' OR ind.birth1 LIKE \'%'.$tab[$i].'%\''
                        .' OR ind.death1 LIKE \'%'.$tab[$i].'%\''
                        .' OR com.text LIKE \'%'.$tab[$i].'%\' ) ';
                } else if ( $_GET['approx'] == 'true' ) {  //approx search
                    $query .= 'ind.signature LIKE \'%'.searchize( $tab[$i] ).'%\' ';
                }
                if ( $i < $nb - 1 ) {
                    $query .= 'AND ';
                }
            }
        } else {                                //IS Global search
            //take privacy settings from 1st genealogy in info file
            $pquery = 'SELECT living_names, living_birth from '.$pgv->moduleTable('privacy') ;
            $privacy = $db->Execute( $pquery );

            $query = 'SELECT ind.genID, ind.ID , ind.name , ind.firstname , ind.birth_range
            , ind.birth1 , ind.birth2 , ind.birth_phrase , ind.death_range
            , ind.death1 , ind.death2 , ind.death_phrase , info.genID'
                .' FROM '.$pgv->table['individuals'].' AS ind , '
                .$pgv->table['info'].' AS info'
                .' WHERE ';
                //add WHERE clause

            if ($privacy->fields['living_names']=='Y'){  //add privacy check
                $query .= '(ind.birth1 < "'.$privacy->fields['living_birth']
                .'-00-00" OR ind.death1 > "0000-00-00") AND ';
            }

            for ( $i = 0 ; $i < $nb ; $i++ ) {
                if ( !isset( $_GET['approx'] ) OR empty( $_GET['approx'] ) ) {
                    //AND check certain items against ea search mote
                    $query .= '( ind.name LIKE \'%'.$tab[$i].'%\''
                        .' OR ind.firstname LIKE \'%'.$tab[$i].'%\''
                        .' OR ind.birth1 LIKE \'%'.$tab[$i].'%\''
                        .' OR ind.death1 LIKE \'%'.$tab[$i].'%\' ) '
                        .' AND ';
                } else if ( $_GET['approx'] == 'true' ) {
                    $query .= 'ind.signature LIKE \'%'.searchize( $tab[$i] ).'%\' AND ';
                }
            }
            $query .= 'ind.genID = info.genID';
        }

        if ( empty( $_GET['page_nb'] ) ) {
            $_GET['page_nb'] = 1;
        }

        $result = $db->PageExecute( $query, $settings->fields['result_number'], $_GET['page_nb'] );
        if ($result === false) die('search failed: '.$query);
        
        $i = -1; //init to start at 0 when incremented
        if ( !$result->EOF ) {  //there WAS some results
            while ( !$result->EOF ) {
                if ( $pgv->context['isGen'] ) {
                    $genID2 = $pgv->context['genID'];    //genID from CONTEXT
                } else {
                    $genID2 = $result->fields['genID'];  //genID from RESULT
                }
                //need to look up ind a second time with ind.class to apply privacy
                $i++; //prob replace this with row #jg
                //set up a link with each name returned from the search
                $pgv_search['results'][$i]['name'] = '<a href=\'index.php?genID='
                .$genID2.'&amp;page=ind&amp;id='.$result->fields['ID']
                .'&amp;ul='.$pgv->context['ul'].'\'>'.stripslashes($result->fields['name'])
                .' '.stripslashes( $result->fields['firstname'] ).'</a>';
                    $pgv_search['results'][$i]['name'] .= '&nbsp;<font size=\'2\'>('
                    .convert_sql_to_date( $result->fields['birth_range']
                    , $result->fields['birth1'] , $result->fields['birth2']
                    , $result->fields['birth_phrase'] , 3 ).' - '
                    .convert_sql_to_date( $result->fields['death_range']
                    , $result->fields['death1'] , $result->fields['death2']
                    , $result->fields['death_phrase'] , 3 ).')</font>';
                // Occupation is NOT in the ind record currently
                //if ( ( eregi( $reg_tab , $result->fields['occupation'] ) ) )
                //{
                //    $pgv_search['results'][$i]['occupation']
                //    = eregi_replace( $reg_tab , '<span class="occurence">\0</span>'
                //    , quote( stripslashes( $result->fields['occupation'] ) , $tab ) );
                //}
                if ( ( eregi( $reg_tab , $result->fields['text'] , $regs ) ) )
                {
                    $pgv_search['results'][$i]['note']
                    = eregi_replace( $reg_tab , '<span class="occurence">\0</span>'
                    , quote( stripslashes( $result->fields['text'] ) , $tab ) );
                }
                $result->MoveNext();
            }
            //go back to the first result returned and set up nav links
            $result->MoveFirst();

            if ( !$result->EOF
            && ( !$result->AtFirstPage()
            || !$result->AtLastPage() ) ) {
                if ( !$result->AtFirstPage() ) {
                $pgv_search['navigation'] = '<a href=\'index.php?genID='
                .$pgv->context['genID'].'&amp;page=search&amp;text='.$_GET['text']
                .'&amp;page_nb='.( $result->AbsolutePage() - 1 )
                .'&amp;ul='.$pgv->context['ul'].'\'>'.GV_SEARCH_PREVIOUS.'</a>';
                }

                if ( !$result->AtFirstPage() && !$result->AtLastPage() ) {
                    $pgv_search['navigation'] .= ' | ';
                }

                if ( !$result->AtLastPage() ) {
                $pgv_search['navigation'] .= '<a href=\'index.php?genID='
                .$pgv->context['genID'].'&amp;page=search&amp;text='
                .$_GET['text'].'&amp;page_nb='.( $result->AbsolutePage() + 1 )
                .'&amp;ul='.$pgv->context['ul'].'\'>'.GV_SEARCH_NEXT.'</a>';
                }
            }
        } else { //there were NO results, try approx. search
            //check to see if it is enabled
            $result = $db->Execute( 'SELECT searchized FROM '.$pgv->table['info']
            .' WHERE genID=\''.$pgv->context['genID'].'\'' );
            //and link back to search page for the approx search
            if ( ( !isset( $_GET['approx'] ) OR empty( $_GET['approx'] ) )
            AND ( $result->fields['searchized'] ) ) {
                $pgv_search['soundex'] = true;
                $pgv_search['soundex_form'] = GV_APPROXIMATIVE_SEARCH
                    .'<form name=\'approximative\' method=\'get\' action=\''
                    .$pgv->environment['rootUrl'].'/index.php\'>'
                    .'<input type=\'text\' name=\'text\' value=\''
                    .$_GET['text'].'\' style=\'input1\'>'
                    .'<input type=\'hidden\' name=\'genID\' value=\''
                    .$pgv->context['genID'].'\'>'
                    .'<input type=\'hidden\' name=\'page\' value=\'search\'>'
                    .'<input type=\'hidden\' name=\'approx\' value=\'true\'>'
                    .'<input type=\'hidden\' name=\'ul\' value=\''.$pgv->context['ul'].'\'>'
                    .'<input type=\'hidden\' name=\'start\' value=\'0\'>'
                    .'<input type=\'submit\' value=\''.GV_SEARCH_BUTTON_LABEL.'\'>'
                    .'</form>';
            }
        }
    }
    $pgv_search['no_result'] = GV_SEARCH_NORESULT;
    $theme->assign( 'pgv_search' ,  $pgv_search );
?>