<?php
/*
 * Poplar Gedcom Viewer
 * Copyright (C) 2002-2003 Nicolas de Vulpian
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*
 * Extensively rewritten 10/2003
 * changes Copyright 2003 by J.R.Grotjan
*/
?>
<?php
    // Displays some "statistics" about the family

    $pgv->setMainMenuTitle( GV_STATS );

    // Display the 20 most common surnames

    if ( $pgv->context['isGen'] ) {
        $result = $db->SelectLimit( 'SELECT name, count( name ) AS nb FROM '.$pgv->table['individuals'].' WHERE genID = '.$pgv->context['genID'].' GROUP BY name ORDER BY nb DESC', 20 , 0 );
    } else {
        $result = $db->SelectLimit( 'SELECT name, count( name ) AS nb FROM '.$pgv->table['individuals'].' GROUP BY name ORDER BY nb DESC', 20 , 0 );
    }
    if ( $result === false ) { die ('Failed '.GV_20_SURNAMES); }

    $i = 0;
    while (    !$result->EOF ) {
        $pgv->getUrl();
        $pgv->setUrl( 'page' , 'surname' );
        $pgv->setUrl( 'idSurname' , urlencode( $result->fields['name'] ) );

        $pgv_stats_surnames[$i] = $pgv->makeLink( !empty( $result->fields['name'] ) ? stripslashes( $result->fields['name'] ) : GV_NO_SURNAME ).'&nbsp;('.$result->fields['nb'].')';

        $i++;
        $result->MoveNext();
    } 
    
    // Diplays the 20 last weddings
    if ( $pgv->context['isGen'] ) {   //dont display for global search

        $query = 'SELECT ind1.genID as genID1 , ind1.ID as ID1
        , ind1.name AS name1 , ind1.firstname AS firstname1 , ind1.birth1 AS birth1
        , ind2.genID as genID2 , ind2.ID as ID2
        , ind2.name AS name2 , ind2.firstname AS firstname2 , ind2.birth1 AS birth2
        , fam.genID, fam.wedding_range , fam.wedding1
        , fam.wedding2 , fam.wedding_phrase FROM '
        .$pgv->table['individuals'].' as ind1 , '
        .$pgv->table['individuals'].' as ind2 , '
        .$pgv->table['families'].' as fam WHERE fam.genID = '.$pgv->context['genID']
        .' AND ind1.genID = '.$pgv->context['genID'].' AND ind2.genID = '.$pgv->context['genID']
        .' AND ind1.ID = fam.father AND ind2.ID = fam.mother '
        .'ORDER BY fam.wedding1 DESC' ;
        $indiv = $db->SelectLimit($query , 20 , 0 );
        if ( $indiv === false ) die ('Failed last 20 weddings: '.$query);
        
        $i = 0;
        while ( !$indiv->EOF ) {
            if ( !$hide( 'unions', $indiv->fields['birth1'] )
            && !$hide( 'unions', $indiv->fields['birth2'] ) ) {
                $pgv_stats_weddings[$i] = '<table><tr><td align="right" width="100" >'
                .convert_sql_to_date( $indiv->fields['wedding_range']
                , $indiv->fields['wedding1'] , $indiv->fields['wedding2']
                , $indiv->fields['wedding_phrase'] , 3 )
                .'&nbsp<td>&nbsp';

                $pgv->getUrl();
                $pgv->setUrl( 'page' , 'ind' );
                $pgv->setUrl( 'indID' , $indiv->fields['ID1'] );
                $pgv_stats_weddings[$i] .= $pgv->makeLink( $indiv->fields['firstname1']
                .' '.$indiv->fields['name1'] ).' + ';
                $pgv->setUrl( 'indID' , $indiv->fields['ID2'] );
                $pgv_stats_weddings[$i] .= $pgv->makeLink( $indiv->fields['firstname2']
                .' '.$indiv->fields['name2']
                .'</tr></table>' );

            }
            $i++;
            $indiv->MoveNext();
        }
    }

    // Diplays the 20 last births

    $i = 0;
    if ( !empty( $pgv->context['genID'] ) ) {      //stats for single genName//
        $indiv = $db->SelectLimit( 'SELECT genID, ID, name, firstname, birth_range
        , birth1, birth2, birth_phrase FROM '
        .$pgv->table['individuals'].' WHERE genID = '.$pgv->context['genID']
        .' ORDER BY birth1 DESC', 20 , 0 );

        if ($indiv === false) die ('Failed last 20 birth');

        while ( !$indiv->EOF ) {
            if  ( !$hide( 'dates' , $indiv->fields['birth1'] ) ) {
                $pgv_stats_births[$i] = '<table><tr><td align="right" width="100" >'
                .convert_sql_to_date( $indiv->fields['birth_range'], $indiv->fields['birth1'], $indiv->fields['birth2'], $indiv->fields['birth_phrase'], 3 )
                .'&nbsp<td>&nbsp'.link_ind( $indiv->fields['genID'], $indiv->fields['ID'], $indiv->fields['name'], $indiv->fields['firstname'], $_GET['ul'] )
                .'</tr></table>';
            }
            $i++;
            $indiv->MoveNext();
        }
    } else {                                         //stats for global index//
        $indiv = $db->SelectLimit( 'SELECT info.genID, ind.genID, ind.ID
        , ind.name, ind.firstname, ind.birth_range, ind.birth1
        , ind.birth2, ind.birth_phrase FROM '
        .$pgv->table['info'].' AS info ,'.$pgv->table['individuals']
        .' AS ind WHERE info.genID = ind.genID ORDER BY birth1 DESC', 20, 0 );

        if ($indiv === false) die ('Failed last 20 birth');

        while ( !$indiv->EOF ) {
            $pgv_stats_births[$i] = '<table><tr><td align="right" width="100" >'
            .convert_sql_to_date( $indiv->fields['birth_range']
            , $indiv->fields['birth1'] , $indiv->fields['birth2']
            , $indiv->fields['birth_phrase'] , 3 )
            .'&nbsp<td>&nbsp'.link_ind( $indiv->fields['genID']
            , $indiv->fields['ID'] , $indiv->fields['name']
            , $indiv->fields['firstname'] , $_GET['ul'] )
            .'</tr></table>';

            $i++;
            $indiv->MoveNext();
        }
    }


    // Diplays the 20 oldest living people

    $i = 0;
    if ( !empty( $pgv->context['genID'] )  ) {
        $indiv = $db->SelectLimit( 'SELECT ID, name , firstname , birth_range
        , birth1 , birth2 , birth_phrase FROM '
        .$pgv->table['individuals'].' WHERE genID = '.$pgv->context['genID']
        .' AND birth1 > "1900-01-01" AND death1 = "0000-00-00" ORDER BY birth1 ASC' , 20 , 0 );
        if ($indiv === false) die ('Failed last 20 oldest living people');

        while ( !$indiv->EOF ) {
            if  ( !$hide( 'dates' , $indiv->fields['birth1'] ) ) {
                $pgv_stats_older[$i] = '<table><tr><td align="right" width="100" >'
                .convert_sql_to_date( $indiv->fields['birth_range']
                , $indiv->fields['birth1'] , $indiv->fields['birth2']
                , $indiv->fields['birth_phrase'] , 3 )
                .'&nbsp<td>&nbsp'.link_ind( $pgv->context['genID']
                , $indiv->fields['ID'] , $indiv->fields['name']
                , $indiv->fields['firstname'] , $_GET['ul'] )
                .'</tr></table>';
            }
            $i++;
            $indiv->MoveNext();
        }
    } else {
        $indiv = $db->SelectLimit( 'SELECT info.genID , ind.genID , ind.ID , ind.name
        , ind.firstname , ind.birth_range , ind.birth1 , ind.birth2
        , ind.birth_phrase FROM '.$pgv->table['info'].' AS info , '
        .$pgv->table['individuals']
        .' AS ind WHERE info.genID = ind.genID AND birth1 > "1900-01-01" '
        .'AND death1 = "0000-00-00" ORDER BY birth1 ASC' , 20 , 0 );
        if ($indiv === false) die ('Failed last 20 oldest living people');

        while ( !$indiv->EOF ) {
            $pgv_stats_older[$i] = '<table><tr><td align="right" width="100" >'
            .convert_sql_to_date( $indiv->fields['birth_range']
            , $indiv->fields['birth1'] , $indiv->fields['birth2']
            , $indiv->fields['birth_phrase'] , 3 )
            .'&nbsp<td>&nbsp'.link_ind( $indiv->fields['genID']
            , $indiv->fields['ID'] , $indiv->fields['name']
            , $indiv->fields['firstname'] , $_GET['ul'] )
            .'</tr></table>';

            $i++;
            $indiv->MoveNext();
        }
    }

    $theme->assign( 'pgv_stats_anchors' , array(    '<a href=\'#surnames\'>'.GV_20_SURNAMES.'</a>' ,
                                                    '<a href=\'#weddings\'>'.GV_20_WEDDING.'</a>' ,
                                                    '<a href=\'#births\'>'.GV_20_BIRTH.'</a>' ,
                                                    '<a href=\'#older\'>'.GV_20_OLDER.'</a>' ) );

    $theme->assign( 'pgv_stats_surnames_title' , GV_20_SURNAMES );
    $theme->assign( 'pgv_stats_weddings_title' , GV_20_WEDDING );
    $theme->assign( 'pgv_stats_births_title' , GV_20_BIRTH );
    $theme->assign( 'pgv_stats_older_title' , GV_20_OLDER );

    $theme->assign( 'pgv_stats_surnames' , $pgv_stats_surnames );
    $theme->assign( 'pgv_stats_weddings' , $pgv_stats_weddings );
    $theme->assign( 'pgv_stats_births' , $pgv_stats_births );
    $theme->assign( 'pgv_stats_older' , $pgv_stats_older );
?>