<?php
/*
 * Poplar Gedcom Viewer
 * Copyright (C) 2002-2003 Nicolas de Vulpian
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*
 * Extensively rewritten 10/2003
 * changes Copyright 2003 by J.R.Grotjan
*/
?>
<?php
// welcome page
    $pgv->setMainMenuTitle( '' );

    if ( $pgv->context['isGen'] ) {

        $alphabet = $db->Execute( 'SELECT DISTINCT LEFT( name , 1 ) AS letter from '
        .$pgv->table['individuals'].' WHERE genID = '.$pgv->context['genID']
        .' ORDER BY letter' );
        if ( $alphabet === false ) die( 'Failed alphabet' );

        $surnames = $db->Execute( 'SELECT count( DISTINCT name ) AS nb FROM '
        .$pgv->table['individuals'].' WHERE genID = '.$pgv->context['genID'] );
        if ( $surnames === false ) die( 'Failed surname count' );

        $families = $db->Execute( 'SELECT count( famID ) AS nb FROM '
        .$pgv->table['families'].' WHERE genID = '.$pgv->context['genID'] );
        if ( $families === false ) die( 'Failed family count' );

        $indiv = $db->Execute( 'SELECT count( ID ) AS nb FROM '
        .$pgv->table['individuals'].' WHERE genID = '.$pgv->context['genID'] );
        if ( $indiv === false ) die( 'Failed' );

        $pgv->getUrl();
        $pgv->setUrl( 'page' , 'surnames_list' );
        $pgv_welcome_menus[] = $pgv->makeLink( GV_SURNAMES_LIST );

        $pgv->setUrl( 'page' , 'stats' );
        $pgv_welcome_menus[] = $pgv->makeLink( GV_STATS );

        $pgv->setUrl( 'page' , 'alph' );

        while ( !$alphabet->EOF ) {
            if ( preg_match( '/[A-Z]/' , strtoupper( $alphabet->fields['letter'] ) ) ) {
                $pgv->setUrl( 'letter' , strtoupper( $alphabet->fields['letter'] ) );
                $temp .= $pgv->makeLink( strtoupper( $alphabet->fields['letter'] ) )
                    .'&nbsp;';
            }
            $alphabet->MoveNext();
        }
        $pgv_welcome_menus[] = $temp;

        $pgv_welcome_text = fill( GV_HOME_1 , $indiv->fields['nb']
        , $families->fields['nb'] , $surnames->fields['nb'] );
    } else {  //Global index
        $result = $db->Execute( 'SELECT SUM(ID) as sum FROM '.$pgv->table['individuals'] );
        if ( $result === false ) die ('Failed to select indexed in '
        .$pgv->table['individuals']);

        if ( $result->fields['sum'] ) {
            $alphabet = $db->Execute( 'SELECT DISTINCT LEFT( name , 1 ) AS letter from '
            .$pgv->table['individuals'].' ORDER BY letter' );

            if ( $alphabet === false ) die( 'Failed' );

            $surnames = $db->Execute( 'SELECT count( DISTINCT name ) AS nb FROM '
            .$pgv->table['individuals'] );
            if ( $surnames === false ) die( 'Failed' );

            $families = $db->Execute( 'SELECT count( famID ) AS nb FROM '
            .$pgv->table['families'] );
            if ( $families === false ) die( 'Failed family count' );

            $indiv = $db->Execute( 'SELECT count( ID ) AS nb FROM  '
            .$pgv->table['individuals'] );
            if ( $indiv === false ) die( 'Failed' );

            $pgv->getUrl();
            $pgv->setUrl( 'page' , 'surnames_list' );
            $pgv_welcome_menus[] = $pgv->makeLink( GV_SURNAMES_LIST );

            $pgv->setUrl( 'page' , 'stats' );
            $pgv_welcome_menus[] = $pgv->makeLink( GV_STATS );

            while ( !$alphabet->EOF ) {
                $pgv->setUrl( 'page' , 'alph' );
                $pgv->setUrl( 'letter' , $alphabet->fields['letter'] );
                $temp .= $pgv->makeLink( $alphabet->fields['letter'] )
                    .'&nbsp;';

                $alphabet->MoveNext();
            }
            $pgv_welcome_menus[] = $temp;
            $pgv_welcome_text = fill( GV_HOME_1 , $indiv->fields['nb']
            , $families->fields['nb'] , $surnames->fields['nb'] );
        }

        $result = $db->Execute( 'SELECT * FROM '.$pgv->table['info'].';' );
        if ( $result === false ) die ('failed list' );

        $pgv_welcome_list = GV_LIST;
        $pgv->getUrl();

        while ( !$result->EOF ) {
            $pgv->setUrl( 'genID' , $result->fields['genID'] );
            $pgv_welcome_genealogies[] =
            $pgv->makeLink( $result->fields['title'] ? $result->fields['title'] : GV_GENEALOGY
            .' #'.$result->fields['genID'] );
            
            $result->MoveNext();
        }
    }

    if ( !$pgv->context['advanced'] ) {   //NOT Advanced

        $pgv->getUrl();
        $pgv->setUrl( 'advanced' , 1 );

        $pgv_welcome_searchbox = '<form name=\'search\' action=\''.$pgv->environment['rootUrl'].'/index.php\' method=\'get\'>'
        .'<input type=\'hidden\' name=\'genID\' value=\''.$pgv->context['genID'].'\'>'
        .'<input type=\'hidden\' name=\'page\' value=\'search\'>'
        .'<input type=\'text\' name=\'text\' style=\'input1\'>'
        .'<input type=\'hidden\' name=\'ul\' value=\''.$pgv->context['ul'].'\'>'
        .'<input type=\'hidden\' name=\'start\' value=\'0\'>'
        .'<input type=\'submit\' value=\''.GV_SEARCH_BUTTON_LABEL.'\'>'
        .'<div align=\'left\'>'
        .$pgv->makeLink( '<font size=\'-1\'>'.GV_ADVANCED_SEARCH_LABEL.'</font>' )
        .'</div>'
        .'</form>';
    } else {                           //IS Advanced
        $pgv_welcome_searchbox = '<form name=\'search\' action=\''
        .$pgv->environment['rootUrl'].'/index.php\' method=\'get\'>'
        .'<input type=\'hidden\' name=\'genID\' value=\''.$pgv->context['genID'].'\'>'
        .'<input type=\'hidden\' name=\'page\' value=\'asearch\'>'
        .'<table>'
        .'<tr><td>'.fill( GV_FIRST_NAME , '' )
        .' </td><td><input type=\'text\' name=\'firstname\' style=\'input1\'></td><td rowspan=\'2\'><input type=\'submit\' value=\''.GV_SEARCH_BUTTON_LABEL.'\'></td></tr>'
        .'<tr><td>'.fill( GV_LAST_NAME , '' )
        .' </td><td><input type=\'text\' name=\'name\' style=\'input1\'></td></tr>';

        if ( $pgv->context['isGen'] ) {
            //$pgv_welcome_searchbox .= '<tr><td>'.fill( GV_OCCUPATION , '' )
            //.' </td><td><input type=\'text\' name=\'occupation\' style=\'input1\'></td></tr>';
            $pgv_welcome_searchbox .= '<tr><td>'.fill( GV_COMMENTS , '' )
            .' </td><td><input type=\'text\' name=\'comment\' style=\'input1\'></td></tr>';
        }

        $pgv->getUrl();
        $pgv->setUrl( 'advanced' , '' );

        $pgv_welcome_searchbox .= '</table>'
        .'<input type=\'hidden\' name=\'ul\' value=\''.$pgv->context['ul'].'\'>'
        .'<input type=\'hidden\' name=\'start\' value=\'0\'>'
        .'<div align=\'left\'>'
        .$pgv->makeLink( '<font size=\'-1\'>'.GV_SEARCH_LABEL.'</font>' )
        .'</div>'
        .'</form>';
    }
    $theme->assign( 'pgv_welcome_search'        , GV_SEARCH_LABEL );
    $theme->assign( 'pgv_welcome_menus'         , $pgv_welcome_menus );
    $theme->assign( 'pgv_welcome_text'          , $pgv_welcome_text );
    $theme->assign( 'pgv_welcome_searchbox'     , $pgv_welcome_searchbox );
    $theme->assign( 'pgv_welcome_list'          , $pgv_welcome_list );
    $theme->assign( 'pgv_welcome_genealogies'   , $pgv_welcome_genealogies );
    $theme->assign( 'pgv_welcome_no_genealogy'  , GV_INDEX_NO_TABLE );
?>