<?php
/*
 * Poplar Gedcom Viewer
 * Copyright (C) 2002-2003 Nicolas de Vulpian
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*
 * Extensively rewritten 10/2003
 * changes Copyright 2003 by J.R.Grotjan
*/
?>
<?php

$env['pgvVersion'] = '2.0';


// *******************************
// * Do not edit below this line *
// *******************************
//comment out below line to disable debugging
//error_reporting ( E_ALL );

// Connection to the database

set_magic_quotes_runtime( 0 );
include_once( $env['rootPath'].'/include/adodb/adodb.inc.php' );

$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;
$db = NewADOConnection( $dbtype );
$db->Connect( $dbhost , $dbuser , $dbpassword , $dbname);
if ( $db === false ) die ( 'Connection failed' );

// Loading PHP Gedcom Viewer global settings

include_once( $env['rootPath'].'/include/functions.php' );

include_once( $env['rootPath'].'/include/pgv.class.php' );
include_once( $env['rootPath'].'/include/individual.class.php' );

if ( !isset( $skipQueryDB ) ) { $skipQueryDB = false; }

$pgv = new Pgv( $skipQueryDB );

if ( !isset( $_GET['step'] ) OR ( empty( $_GET['step'] ) ) ) {
    $settings = $db->Execute( 'SELECT * FROM '.$pgv->table['settings'].' WHERE sID = 1' );
    if ($settings === false) die('Failed to load settings. Please run the <a href=\'.\install.php\'>install script</a> first!');  

    $db->debug = $settings->fields['debug_mode'];
}

define( 'SMARTY_DIR' , $pgv->environment['rootPath'].'/include/smarty/' );
include_once( $pgv->environment['rootPath'].'/include/smarty/Smarty.class.php' );

$theme = new Smarty();

$theme->template_dir    = $pgv->environment['rootPath'].'/themes/'.$pgv->context['theme'];
$theme->compile_dir     = SMARTY_DIR.'templates_c';
$theme->config_dir      = SMARTY_DIR.'configs';
$theme->cache_dir       = array( SMARTY_DIR.'plugins' );
$theme->caching         = false;
$theme->use_sub_dirs    = false;


?>