<?php
/*
 * Poplar Gedcom Viewer
 * Copyright (C) 2002-2003 Nicolas de Vulpian
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*
 * Extensively rewritten 10/2003
 * changes Copyright 2003 by J.R.Grotjan
*/
?>
<?php

define( 'DEFAULT_NAME_FORMAT' , 'f L' );

class Individual {
    var $genID;
    var $indID;

    var $fullName;
    var $lastName;
    var $firstName;

    var $birth;
    var $hiddenbirth;
    var $death;
    var $hiddendeath;
    var $burial;
    var $wedding;
    var $divorce;

    var $famID;
    var $spouses;
    var $spousesCount;
    var $child;
    var $childCount;

    var $occupation;
    var $commentID;
    var $note;
    var $fact;
    var $factsCount;

    function individual( $genID , $indID ) {
        $this->genID  = $genID;
        $this->indID  = $indID;
    }

    function getIndividual() {
        global $db, $pgv;          //database handle, pgv class vars

        $query = 'SELECT *'
            .' FROM '.$pgv->table['individuals']
            .' WHERE genID = '.$this->genID.' AND id = '.$this->indID;
        $result = $db->Execute( $query );
        if ( $result === false ) { die( 'Failed class individual, method getIndividual(), details: '.$query ); }

        if ( !$result->EOF ) {
            //save these ONLY for privacy checking
            $this->hiddenbirth['date1']  = $result->fields['birth1'];
            $this->hiddendeath['date1']  = $result->fields['death1'];

            $this->famC            = $result->fields['famC'];
            //privacy check
            if ( ($pgv->privacy['living_names'] == 'Y'
            && isLiving( $this->hiddenbirth['date1'] , $this->hiddendeath['date1'] )===false )
            || $pgv->privacy['living_names'] != 'Y'){

                $this->lastName        = stripslashes( $result->fields['name'] );
                $this->firstName       = stripslashes( $result->fields['firstname'] );
                $this->fullName        = $this->fullName();
            }else{
                //$this->lastName        = '';
                $this->firstName       = GV_LIVING_PERSON;
                $this->fullName        = $this->fullName();
            }
            $this->gender              = $result->fields['gender'];

            //privacy check
            if ( $pgv->privacy['all_dates'] != 'Y'
            &&( ($pgv->privacy['living_dates'] == 'Y'
            && isLiving( $this->hiddenbirth['date1'] , $this->hiddendeath['date1'] )===false )
            || $pgv->privacy['living_dates'] != 'Y') ){

                $this->birth['range']  = $result->fields['birth_range'];
                $this->birth['date1']  = $result->fields['birth1'];
                $this->birth['date2']  = $result->fields['birth2'];
                $this->birth['phrase'] = stripslashes( $result->fields['birth_phrase'] );

                if ( formatDate($this->birth, 1) == '' && $this->birth['phrase'] == '' ){
                    $fact = $this->getFact('CHR');                               //christening
                    if ($fact == '') $fact = $this->getFact('BAPM');             //baptism
                    if ( $fact != false ){
                        $this->birth['date1'] = $fact[0]['date1'];               //close substitute
                        $this->birth['range'] = 'ABT';
                    }
                }

                $this->death['range']  = $result->fields['death_range'];
                $this->death['date1']  = $result->fields['death1'];
                $this->death['date2']  = $result->fields['death2'];
                $this->death['phrase'] = stripslashes( $result->fields['death_phrase'] );

                $this->burial['date1'] = $result->fields['burial1'];

                if ( formatDate($this->death, 1) == '' && $this->death['phrase'] == '' ){
                    $fact = $this->getFact('BURI');                              //burial
                    if ( $fact != false ){
                        $this->death['date1'] = $fact[0]['date1'];               //close substitute
                        $this->death['range'] = 'ABT';
                    }
                }

            }
            if ( $pgv->privacy['all_places'] != 'Y'
            && ( ($pgv->privacy['living_places'] == 'Y'
            && isLiving( $this->hiddenbirth['date1'] , $this->hiddendeath['date1'] )===false )
            || $pgv->privacy['living_places'] != 'Y') ){

                $this->birth['place']  = stripslashes( $result->fields['birth_place'] );
                $this->death['place']  = stripslashes( $result->fields['death_place'] );
                $this->death['cause']  = stripslashes( $result->fields['death_cause'] );
                $this->burial['place'] = stripslashes( $result->fields['burial_place'] );
            }
            //privacy check
            if ( $pgv->privacy['all_notes'] != 'Y'
            && ( ($pgv->privacy['living_notes'] == 'Y'
            && isLiving( $this->hiddenbirth['date1'] , $this->hiddendeath['date1'] )===false )
            || $pgv->privacy['living_notes'] != 'Y') ){

                $query2 = 'SELECT text'
                    .' FROM '.$pgv->table['comments']
                    .' WHERE commentID = '.$result->fields['commentID'];
                $result2 = $db->Execute( $query2 );
                if ( $result2 === false ) { die ( 'Failed class individual, method getIndividual(), comment' ); }
                $this->commentID = $result->fields['commentID'];
                $this->note = nl2br( stripslashes( $result2->fields['text'] ) );
            }
        }
    }

    function fullName( $nameFormat = DEFAULT_NAME_FORMAT ) {
        $fullName = '';
        for ( $i = 0 ; $i < strlen( $nameFormat ) ; $i++ ) {
            switch ( $nameFormat[$i] ) {
                case 'f' :
                    $fullName .= $this->firstName;
                    break;
                case 'F' :
                    $fullName .= strtoupper( $this->firstName );
                    break;
                case 'l' :
                    $fullName .= $this->lastName;
                    break;
                case 'L' :
                    $fullName .= strtoupper( $this->lastName );
                    break;
                default :
                    $fullName .= $nameFormat[$i];
            }
        }
        return $fullName;
    }

    function getParents() {
        global $db, $pgv;

        $db->Execute('SET OPTION SQL_BIG_SELECTS=1');
        $query = 'SELECT ind.genID , ind.ID , ind.name , ind.firstname , ind.gender'
            .' FROM '.$pgv->table['individuals'].' AS ind , '
            .$pgv->table['families'].' AS fam'
            .' WHERE fam.genID = '.$pgv->context['genID']
            .' AND fam.famID = '.$this->famC
            .' AND ind.genID = '.$pgv->context['genID']             //family of selected individual
            .' AND ( fam.father = ind.ID OR fam.mother = ind.ID )'    //match either father or mother
            .' ORDER BY ind.gender DESC';                             //sort with the Male first
        $result = $db->Execute( $query );
        if ( $result === false ) { die ( 'Failed class individual, method getParents()' ); }

        while ( !$result->EOF ) {
            $i = $result->CurrentRow();

            $this->parents[$i] = new individual( $this->genID , $result->fields['ID'] );
            $this->parents[$i]->getIndividual();

            $result->MoveNext();
        }
        $this->parentsCount = $result->RecordCount();

        if ( $this->parentsCount > 0 ) {
            return true;
        } else {
            return false;
        }
    }

    function getChild() {
        global $db, $pgv;

        $db->Execute('SET OPTION SQL_BIG_SELECTS=1');
        $query = 'SELECT ind.ID , ind.name , ind.firstname , ind.birth1'
            .' FROM '.$pgv->table['individuals'].' AS ind , '
            .$pgv->table['families'].' AS fam'
            .' WHERE ind.genID = '.$pgv->context['genID']
            .' AND fam.genID = '.$pgv->context['genID']
            .' AND ind.famC = fam.famID'
            .' AND ( fam.mother = '.$this->indID.' OR fam.father = '.$this->indID.')' //all indID where selected ind
            .' ORDER BY ind.birth1 ';                                                 //=mother or father

        $result = $db->Execute( $query );
        if ( $result === false ) { die ( 'Failed class individual, method getChild()' ); }

        while ( !$result->EOF ) {
            $i = $result->CurrentRow();

            $this->child[$i] = new individual( $this->genID , $result->fields['ID'] );
            $this->child[$i]->getIndividual();

            $result->MoveNext();
        }
        $this->childCount = $result->recordCount();

        if ( $this->childCount > 0 ) {
            return true;
        } else {
            return false;
        }
    }

    function getSpouses() {
        global $db, $pgv;
        //privacy check
        if ( $pgv->privacy['all_unions'] == 'Y'
        || ($pgv->privacy['living_unions'] == 'Y'
        && isLiving( $this->hiddenbirth['date1'] , $this->hiddendeath['date1'] ) ) )
            return false;

        $db->Execute('SET OPTION SQL_BIG_SELECTS=1');
        $query = 'SELECT fam.genID, famID, fam.wedding_range , fam.wedding1 , fam.wedding2
        , fam.wedding_phrase , fam.weddingplace , fam.divorce_range
        , fam.divorce1 , fam.divorce2 , fam.divorce_phrase , fam.div
        , fam.commentID , ind.genID, ind.ID , ind.gender , ind.name , ind.firstname
        , com.text AS comment'
            .' FROM '.$pgv->table['families'].' AS fam , '.$pgv->table['individuals'].' AS ind'
            .' LEFT JOIN '.$pgv->table['comments'].' AS com'
            .' ON fam.commentID = com.commentID WHERE ind.genID = '.$this->genID
            .' AND fam.genID = '.$this->genID.' AND';
            if ($this->gender == 'M'){
                $query .= ' fam.father = '.$this->indID.' AND ind.ID = fam.mother';
            }else{
                $query .= ' fam.mother = '.$this->indID.' AND ind.ID = fam.father';
            }
            $query .= ' ORDER BY fam.wedding1';

        $result = $db->Execute( $query );
        if ($result === false) { die ('Failed class individual, method getSpouses()'); }

        while ( !$result->EOF ) {
            $i = $result->CurrentRow();

            $this->spouses[$i]  = new individual( $this->genID , $result->fields['ID'] );
            $this->spouses[$i]->getIndividual();

            $this->spouses[$i]->famID  = $result->fields['famID'];

            $this->spouses[$i]->wedding['range']  = $result->fields['wedding_range'];
            $this->spouses[$i]->wedding['date1']  = $result->fields['wedding1'];
            $this->spouses[$i]->wedding['date2']  = $result->fields['wedding2'];
            $this->spouses[$i]->wedding['phrase'] = stripslashes( $result->fields['wedding_phrase'] );
            $this->spouses[$i]->wedding['place']  = stripslashes( $result->fields['weddingplace'] );

            $this->spouses[$i]->divorce['range']  = $result->fields['divorce_range'];
            $this->spouses[$i]->divorce['date1']  = $result->fields['divorce1'];
            $this->spouses[$i]->divorce['date2']  = $result->fields['divorce2'];
            $this->spouses[$i]->divorce['phrase'] = stripslashes( $result->fields['divorce_phrase'] );
            $this->spouses[$i]->divorce['div']    = $result->fields['div'];

            $this->spouses[$i]->note = nl2br( stripslashes( $result->fields['comment'] ) );
            $this->spouses[$i]->noteID = $result->fields['commentID'];

            $result->MoveNext();
        }
        $this->spousesCount = $result->RecordCount();

        if ( $this->spousesCount > 0 ) {
            return true;
        } else {
            return false;
        }
    }

    function getAllFacts($type = 'I'){
        global $db, $pgv;
        //privacy check
        if ( $pgv->privacy['all_facts'] == 'Y'
        || ( ($pgv->privacy['living_facts'] == 'Y')
        && isLiving( $this->hiddenbirth['date1'] , $this->hiddendeath['date1'] ) ) )
            return false;

        $db->Execute('SET OPTION SQL_BIG_SELECTS=1');
        $query = 'SELECT factID, tag_name , date_range , date1 , date2 , date_phrase , tag_place'
            .' FROM '.$pgv->table['facts']
            .' WHERE genID = '.$this->genID;
        if ($type == 'I'){
            $query = $query.' AND ID = '.$this->indID;
        }else{
            $query = $query.' AND ID = '.$this->famID;
        }
        $query = $query.' AND tag_type = "'.$type.'"'
            .' ORDER BY tag_name ';
        //echo $query.'<br>';
        $result = $db->Execute( $query );
        if ( $result === false ) die( 'Failed class individual, method getFact(): '.$query );

        while ( !$result->EOF ) {
            $i = $result->CurrentRow();
            $this->fact[$i]['factID'] = $result->fields['factID'] ;
            $this->fact[$i]['range']  = $result->fields['date_range'] ;
            $this->fact[$i]['date1']  = $result->fields['date1'] ;
            $this->fact[$i]['date2']  = $result->fields['date2'] ;
            $this->fact[$i]['phrase'] = $result->fields['date_phrase'] ;
            $this->fact[$i]['name']   = $result->fields['tag_name'] ;
            $this->fact[$i]['place']  = $result->fields['tag_place'] ;

            $result->MoveNext();
        }
        $this->factsCount = $result->recordCount();
        if ( $this->factsCount > 0 ) {
            return true;
        } else {
            return false;
        }
    }

    function getFact($tag='', $type='I'){
        global $db, $pgv;

        $query = 'SELECT tag_name , date_range , date1 , date2 , date_phrase , tag_place'
            .' FROM '.$pgv->table['facts']
            .' WHERE genID = '.$this->genID
            .' AND ID = '.$this->indID
            .' AND tag_type = "'.$type.'"';
            if ($tag != ''){
                $query .= ' AND tag_name = "'.$tag.'"';
            }else{
                return '';
            }
        //echo $query.'<br>';

        $result = $db->GetAll( $query );
        //echo var_dump($result).'<br>';
        if ( $result === false ){
            return '';
        }else{
            return $result;
        }
    }
}

