<?php
/*
 * PHP Gedcom Viewer
 * Copyright (C) 2002-2003 Nicolas de Vulpian
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/*
 * PHP Gedcom Viewer Tree Module v.2.0
 * Copyright (C) 2003 by J.R.Grotjan
 * 
*/
?>
<?php

function add_tree_ind( $genID,$individual_ID,$father_ID,$mother_ID,$gen,$childPos=0,$pg='' ) {
    global $tree ;

    $ind = new individual( $genID , $individual_ID );
    $ind->getIndividual();
    $indnum = count($tree[$gen]);
    $tree[$gen][$indnum]['type']      = 'C';
    $tree[$gen][$indnum]['ID']        = $individual_ID;
    $tree[$gen][$indnum]['gender']    = $ind->gender;
    $tree[$gen][$indnum]['name']      = $ind->lastName;
    $tree[$gen][$indnum]['firstname'] = $ind->firstName;
    $tree[$gen][$indnum]['birth']     = formatDate($ind->birth, 1 );
    $tree[$gen][$indnum]['death']     = formatDate($ind->death, 1 );
    $tree[$gen][$indnum]['childPos']  = $childPos;
    $tree[$gen][$indnum]['fatherID'] = $father_ID;
    $tree[$gen][$indnum]['motherID'] = $mother_ID;
    $tree[$gen][$indnum]['pGender'] = $pg; //pri parent's spouse gender

    if ( $ind->getSpouses() ) {
        for ($i = 0; $i < $ind->spousesCount; $i++){
            $ii = $i+1;
            $tree[$gen][$indnum+$ii]['type']      = 'S';
            $tree[$gen][$indnum+$ii]['ID']        = $ind->spouses[$i]->indID;
            $tree[$gen][$indnum+$ii]['gender']    = $ind->spouses[$i]->gender;
            $tree[$gen][$indnum+$ii]['name']      = $ind->spouses[$i]->lastName;
            $tree[$gen][$indnum+$ii]['firstname'] = $ind->spouses[$i]->firstName;
            $tree[$gen][$indnum+$ii]['birth']     = formatDate($ind->spouses[$i]->birth, 1 );
            $tree[$gen][$indnum+$ii]['death']     = formatDate($ind->spouses[$i]->death, 1 );
            $tree[$gen][$indnum+$ii]['wedding']   = formatDate($ind->spouses[$i]->wedding, 1 );
            $tree[$gen][$indnum+$ii]['spNum']     = $i + 1;   //$i is offset 0
        }
        $tree[$gen][$indnum]['spouseCount'] = $ind->spousesCount;
    }
}

function get_tree_child( $genID , $father_ID, $mother_ID, $gen, $sc, $spNum, $pg ) {
    global $db, $pgv, $tree ;
    if($father_ID > 0 && $mother_ID > 0){
        $db->Execute('SET OPTION SQL_BIG_SELECTS=1');
        $query = 'SELECT ind.ID '
            .' FROM '.$pgv->table['individuals'].' as ind , '
            .$pgv->table['families'].' as fam'
            .' WHERE ind.genID = '.$pgv->context['genID']
            .' AND fam.genID = '.$pgv->context['genID']
            .' AND ind.famC = fam.famID'
            .' AND ( fam.mother = '.$mother_ID.' AND fam.father = '.$father_ID.')' //all indID where selected ind
            .' ORDER BY ind.birth1 ';                                              //=mother or father

        $result = $db->Execute( $query );
        if ( $result === false ) { die ( 'Failed function get_tree_child' ); }
        $childCount = $result->RecordCount();

        $i = $result->CurrentRow();
        while ( !$result->EOF ) {
            $i++;
            if ($i == 1 && $childCount >> 1){  //put correct line type above ea ind.
                $childPos = 'left';            //1st child is far left
            }elseif ($i == $childCount && $childCount >> 1){
                $childPos = 'right';           //last child is far right
            }elseif ( $childCount == 1 ){
                $childPos = 'only';
            }else{
                $childPos = 'middle';          //everyone else is in the middle
            }
            add_tree_ind( $genID, $result->fields['ID'], $father_ID, $mother_ID, $gen, $childPos, $pg );

            $result->MoveNext();
        }
        $this->childCount = $result->recordCount();
    }
    if ($this->childCount == 0 ){
        add_no_issue( $father_ID.$spNum.'A', $father_ID, $mother_ID, $gen, $spNum, 'only', $pg );
        $this->childCount = 1;
    }
    return( $this->childCount );
}

function add_no_issue( $idNum, $father_ID, $mother_ID, $gen, $spNum, $chPos, $pg, $name = M_TREE_NO_ISSUE ){
    global $tree ;
    $indnum = count($tree[$gen]);
    $tree[$gen][$indnum]['ID']           = $idNum;
    $tree[$gen][$indnum]['type']         = 'C';
    $tree[$gen][$indnum]['name']         = $name;
    $tree[$gen][$indnum]['gender']       = 'U';
    $tree[$gen][$indnum]['childPos']     = $chPos;
    $tree[$gen][$indnum]['fatherID']     = $father_ID;
    $tree[$gen][$indnum]['motherID']     = $mother_ID;
    $tree[$gen][$indnum]['pGender']      = $pg;
}

function show_table( $maxgen ) {
    global $pgv, $tree, $table, $table2, $table_dim, $colors, $big_x, $small_x, $y;
    //$table = array();
    //$table2 = array();
    // arrange data for table display
    for ( $g = 1; $g <= count($tree); $g++ ){        //find longest gen line
        $arcount = count($tree[$g]);
        if ( $arcount > $maxind) $maxind = $arcount ;
    }
    for ($g = 1; $g <= count($tree); $g++) {                //ea. gen. is a row
        $col = 0;    //start at col. 1
        $table[$g] = arrayFill( 0, $maxind, NULL);         //fill all gen to same len
        for ( $i = 0; $i < count($tree[$g]); $i++ ){        //for each ind in cur gen

            $table[$g][$col]['type']      = $tree[$g][$i]['type'];
            $table[$g][$col]['indID']     = $tree[$g][$i]['ID'];
            $table[$g][$col]['gender']    = $tree[$g][$i]['gender'];
            $table[$g][$col]['name']      = $tree[$g][$i]['name'];
            $table[$g][$col]['firstname'] = $tree[$g][$i]['firstname'];
            $table[$g][$col]['birth']     = $tree[$g][$i]['birth'];
            $table[$g][$col]['death']     = $tree[$g][$i]['death'];
            $table[$g][$col]['wedding']     = $tree[$g][$i]['wedding'];
            $table[$g][$col]['childPos']  = $tree[$g][$i]['childPos'];
            $table[$g][$col]['childCount'] = $tree[$g][$i]['childCount'];
            $table[$g][$col]['spouseCount'] = $tree[$g][$i]['spouseCount'];
            $table[$g][$col]['spNum']       = $tree[$g][$i]['spNum'];
            if ( $tree[$g][$i]['type'] == 'C' ){
                $spouseCount = $tree[$g][$i]['spouseCount'];
                $table[$g][$col]['motherID'] = $tree[$g][$i]['motherID'];
                $table[$g][$col]['fatherID'] = $tree[$g][$i]['fatherID'];
                $table[$g][$col]['pGender']  = $tree[$g][$i]['pGender'];
                if ( $spouseCount >> 0){
                    $table[$g][$col]['splink'] = 1;
                }else{
                    $table[$g][$col]['splink'] = 0;
                }
            }elseif ( $tree[$g][$i]['type'] == 'S' ){
                if( $tree[$g][$i]['spNum'] < $spouseCount ){
                    $table[$g][$col]['splink'] = 1;
                }else{
                    $table[$g][$col]['splink'] = 0;
                }
            }
            $col++;
        }    //end of ind loop
    }    //end of gen loop
//go back and adjust col posit now that all ind are in correct relative posit.
    unset($tree);    //release this memory
    arrange_table($table, $table2);
    $table2 = $table;
    unset($table);    //release memory
    unset($childPar);
    unset($childPar2);
//draw the table//
    echo '<center><div align="center">';
    echo '<table border="0" cellspacing="0" cellpadding="0">';
    for ( $y = 1; $y <= count($table2); $y++ ){     //start of Y loop
        echo '<tr>';                                      //draw lines row above children
        for ( $x = 0; $x < count($table2[$y]); $x++ ){         //cycle thru all ind
            if ( ($y > 1 && $table2[$y][$x]['type'] == 'C') ){      //2nd gen. child and beyond
                echo '<td><img src="'.$pgv->environment['rootUrl']       //child top line
                .'/modules/tree/pictures/'.$table2[$y][$x]['childPos'].'.gif" width="90" height="15" border="0"/></td>';
                $lastChild = 0;
                if ($table2[$y][$x]['childPos'] == 'right' || $table2[$y][$x]['childPos'] == 'only') $lastChild = 1 ;
                if ($lastChild == 0 && $table2[$y][$x]['childPos'] != 'none' ){    //not last child
                    $image1 = 'spouse_skip';
                    $image2 = 'dash';
                }else{                   //is last child
                    $image1 = 'spacer';
                    $image2 = 'spacer';
                }
                echo '<td><img src="'.$pgv->environment['rootUrl']
                .'/modules/tree/pictures/'.$image2.'.gif" width="10" height="15" border="0"/></td>';

            }else{  //'S'pouse or NULL, not 1st gen and not lastchild
                if ( ($table2[$y][$x]['type'] == 'S' || $table2[$y][$x]['type'] == NULL) && $y > 1 && $lastChild != 1 && $x >> 0){
                    $image1 = 'spouse_skip';
                    $image2 = 'dash';
                }else{
                    $image1 = 'spacer';
                    $image2 = 'spacer';
                }
                echo '<td><img src="'.$pgv->environment['rootUrl']   //spouse skip line
                .'/modules/tree/pictures/'.$image1.'.gif" width="90" height="15" border="0"/></td>';

                echo '<td align="top"><img src="'.$pgv->environment['rootUrl']
                .'/modules/tree/pictures/'.$image2.'.gif" width="10" height="15" border="0"/></td>';
            }
        }
        echo '</tr><tr>';                                 //draw ind row
        for ( $x = 0; $x < count($table2[$y]); $x++ ){    //cycle thru all ind
            if ( $y == 1 && $x == 0 && $table2[$y][$x]['fatherID'] >> 0 ){
                 echo '<td><a href=\''.$pgv->environment['rootUrl'].'/index.php?genID='.$_GET['genID'].'&page=module&module=tree&id='.$table2[$y][$x]['fatherID'].'&ul='.$_GET['ul'].'&maxg='.$maxgen.'\'>';
                 echo '<img src=\''.$pgv->environment['rootUrl'].'/modules/tree/pictures/up.gif\' height=\'30\' border=\'0\'/></a></td></td><tr>';
            }
            $pgv->getUrl();
            $pgv->setUrl( 'indID' , $table2[$y][$x]['indID'] );
            $pgv->setUrl( 'maxg' , $maxgen );
            echo '<td width="90" class="'.strtolower($table2[$y][$x]['gender']).'"><font size="-1">';
                if ( $table2[$y][$x]['type'] == 'S' && $table2[$y][$x]['wedding']> 0 ){
                    echo M_TREE_MARRIAGE.$table2[$y][$x]['wedding'].'<br>';
                }
                if ( $table2[$y][$x]['name'] != M_TREE_NO_ISSUE ){
                    echo $pgv->makeLink($table2[$y][$x]['firstname'].' '.$table2[$y][$x]['name']).'<br>';
                }else{
                    echo $table2[$y][$x]['firstname'].' '.$table2[$y][$x]['name'].'<br>';
                }
                if ( trim($table2[$y][$x]['birth']) != '' || trim($table2[$y][$x]['death']) != ''){
                    echo $table2[$y][$x]['birth'].'-'.$table2[$y][$x]['death'].'<br>';
                }
            echo '</font></td>';
            if ( $table2[$y][$x]['splink'] === 1 ){       //add double lines bet. spouses
                $image1 = 'spouse';
                $spl = 1;
            }elseif( $table2[$y][$x]['splink'] === 0 ){   //spacer bet. ind.
                $image1 = 'spacer';
                $spl = 0;
            }elseif( $table2[$y][$x]['splink'] === NULL && $spl == 1 ){   //spacer bet. ind.
                $image1 = 'only';
            }
            echo '<td valign="middle"><img src="'.$pgv->environment['rootUrl']
            .'/modules/tree/pictures/'.$image1.'.gif" width="10"  border="0"/></td>';
        }
        echo '</tr><tr>';
        //draw child line under spouses with children
        for ( $x = 0; $x < count($table2[$y]); $x++ ){   //cycle thru all ind
            if ( $table2[$y][$x]['type'] == 'S' && $table2[$y][$x][childCount] != 0 ){    //add child line below spouse if there is children
                $image1 = 'child';
            }elseif ($x > 0){                                 //spacer bet. ind.
                $image1 = 'spacer';
            }
            echo '<td valign="middle"><img src="'.$pgv->environment['rootUrl']
            .'/modules/tree/pictures/'.$image1.'.gif" width="90" height="15" border="0"/></td>';

            echo '<td valign="middle"><img src="'.$pgv->environment['rootUrl']
            .'/modules/tree/pictures/'.'spacer'.'.gif" width="10" height="15" border="0"/></td>';
        }
        echo '</tr>';
    }    //end of Y loop
    echo '</table>';
    echo '</div></center>';
    unset($table2);
}

function arrange_table(){
    global $table, $table2;
    $arranged = false;
    while ($arranged == false){
        $moved = false;
        $mg = count($table);    //max gen
        for ($g = $mg; $g > 1; $g--) {         //for each gen > 1st
            $posP = pos_tableP($table, ($g-1));        //parent pos
            $posC = pos_tableC($table, $g);           //child pos
            for ( $col = 0 ; $col < count($table[$g]) ; $col++ ){   //check the child row
                if ( $table[$g][$col]['childPos'] == 'left' || $table[$g][$col]['childPos'] == 'only' ){
                    $spPar = $table[$g][$col]['pGender'] == 'F' ? $table[$g][$col]['fatherID'] : $table[$g][$col]['motherID'];
                    if ( $posC[$spPar] < $posP[$spPar] ){
                        $offset = $posP[$spPar] - $posC[$spPar];
                        move_right( $g, ($posC[$spPar]), $offset );
                        $col += $offset; //dont hit same col again
                        unset($posC);
                        $posC = pos_tableC($table, $g);  //update child pos table
                        $moved = true;
                    }
                }
            }
            //update par pos table -- may have been changed while it was adjusted for child posit
            for ( $col = 0 ; $col < count($table[$g-1]) ; $col++ ){ //check the parent row
                if ( $table[$g-1][$col]['type'] == 'S' ){
                    $spPar = $table[$g-1][$col]['indID'];
                    if ( $posP[$spPar] < $posC[$spPar] ){
                        if ( $table[$g-1][$col]['spNum'] == 1 ){ //take pri par with 1st spouse
                            $baseP = ($posP[$spPar])-1;
                            $offset = $posC[$spPar] - $baseP;
                        }else{
                            $baseP = $posP[$spPar];
                            $offset = $posC[$spPar] - $baseP;;
                        }
                        move_right( ($g-1), $baseP, $offset );
                        $col += $offset; //dont hit same col again
                        $posP = pos_tableP($table, ($g-1));
                        $moved = true;
                    }
                }
            }
            unset($posP);
            unset($posC);
        }
        if ($moved == false) $arranged = true;
    }
}

function move_right($gen, $oldpos, $offset){
    global $table, $table2;
    $lastCol = find_eor($table, $gen) + $offset;
    unset($table2);
    $table2[$gen] = arrayFill( 0, $lastCol, NULL);

    for ( $col = $lastCol; $col >= 0 ; $col-- ){  //start at end of row and move all right
        if ($col >= $oldpos){                     //until base col is reached
            $table2[$gen][$col+$offset] = $table[$gen][$col];  //only shift in range specified
        }
    }
    if ( ($oldpos-1) >> 0){
        for ( $col = ($oldpos-1); $col >= 0 ; $col-- ){  //start at end of row and move all right
            $table2[$gen][$col] = $table[$gen][$col];    //remaining cols in same posit
        }
    }
    $table[$gen] = $table2[$gen];
}

function arrayFill($startCol, $numCols, $fillValue){
    $fillAry = array();
    for ( $col = $startCol; $col < $numCols ; $col++ ){
        $fillAry[$col] = $fillValue;
    }
    return $fillAry;
}

function pos_tableC($table, $gen){
    $pos = array();
    for ( $col = 0; $col < count($table[$gen]) ; $col++ ){
        if ( $table[$gen][$col]['childPos'] == 'left' || $table[$gen][$col]['childPos'] == 'only'){
            $spPar = $table[$gen][$col]['pGender'] == 'F' ? $table[$gen][$col]['fatherID'] : $table[$gen][$col]['motherID'];
            $pos[$spPar] = $col;
        }
    }
    return $pos;
}

function pos_tableP($table, $gen){
    $pos = array();
    for ( $col = 0; $col < count($table[$gen]) ; $col++ ){
        if ( $table[$gen][$col]['type'] == 'S' ){
            $pos[ ($table[$gen][$col]['indID']) ] = $col;
        }
    }
    return $pos;
}

function find_eor($table, $g){                //find end of row
    $maxcol = count($table[$g]);               //add needed table cells
    for ($i = $maxcol; $i > 0; $i--){
        if ($table[$g][$i] != NULL) break;
    }
    return $i;
}

?>